//
// BSP_tool - botman's Half-Life BSP utilities
//
// (http://planethalflife.com/botman/)
//
// bsp_view.cpp
//
// Copyright (C) 2001 - Jeffrey "botman" Broome
//
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
//
// See the GNU General Public License for more details at:
// http://www.gnu.org/copyleft/gpl.html
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#include <time.h>

#include "appgene.h"
#include "BspViewConfig_ct.h"
#include "render.h"
#include "HalfLifeMods_ct.h"
#include "Camera.h"

extern BspViewConfig_ct config;
extern HalfLifeMods_ct  HalfLifeMods;
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
int  ScreenWidth;
int  ScreenHeight;
bool bFullScreen;
int  Bitsppix;
int  refresh_rate;

#ifndef __linux__
bool isWindowsApp = TRUE;
#else
bool isWindowsApp = FALSE;
#endif

Render          render;
Camera_ct       Camera;

void Simul_init ( int argc, char * argv[]);
//============================================================
#ifndef __linux__
//---------------------------------------------------
void parseCommandLine (char * lpCmdLine, int & argc, char * argv[])
	{
	int MaxArg_a= argc;
	++MaxArg_a;
	argc= 1;
	argv[0] = "exe";

	while (*lpCmdLine && (argc < MaxArg_a))
		{
		while (*lpCmdLine && ((*lpCmdLine <= 32) || (*lpCmdLine > 126)))
			lpCmdLine++;

		if (*lpCmdLine)
			{
			argv[argc] = lpCmdLine;
			argc++;

			while (*lpCmdLine && ((*lpCmdLine > 32) && (*lpCmdLine <= 126)))
				lpCmdLine++;

			if (*lpCmdLine)
				{
				*lpCmdLine = 0;
				lpCmdLine++;
				}
			}
		}
	}
//-----------------------------------------------------------
int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
const K_MaxArgs= 5;
MSG msg;

HalfLifeMods.init( HalfLifeMods_ct::HalfLifeModsFE);
config. init( BspViewConfig_ct:: ConfigFE);

int argc= K_MaxArgs;
char * argv[ K_MaxArgs];
parseCommandLine( lpCmdLine, argc, argv);
Simul_init(argc, argv);

render. create(::ScreenWidth, ::ScreenHeight, ::Bitsppix,
               ::refresh_rate, ::bFullScreen);

render. InitRender();

ZeroMemory(&msg, sizeof(msg));

while(msg.message != WM_QUIT)
    {
    if(PeekMessage(&msg, 0, 0, 0, PM_REMOVE))
        {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
        } 
    else
        {
		  render.frame();
		  }
	 }
render.shutdown();
return 0;
}
//
//
#else

#include <GL/glut.h>
/*
GLenum doubleBuffer;

static void Args(int argc, char **argv)
{
    GLint i;

    doubleBuffer = GL_FALSE;

    for (i = 1; i < argc; i++) {
        if (strcmp(argv[i], "-sb") == 0) {
            doubleBuffer = GL_FALSE;
        } else if (strcmp(argv[i], "-db") == 0) {
            doubleBuffer = GL_TRUE;
        }
    }
}
*/
void display(void)
{
   render.frame();
}
//-----------------------------------------------------
int main(int argc, char *argv[])
{
//  GLenum type;
    glutInit(&argc, argv);

config. init( config. ConfigFE);

    //Args(argc, argv);

 //   type = GLUT_RGB | GLUT_DEPTH;
 //   type |= (doubleBuffer) ? GLUT_DOUBLE : GLUT_SINGLE;
    glutInitDisplayMode(/*GLUT_RGBA*/GLUT_RGB | GLUT_DEPTH | GLUT_DOUBLE);
    glutInitWindowSize(ScreenWidth, ScreenHeight);
    glutCreateWindow("BSP_view_glut");

	Simul_init(argc, argv);

    render.init();

    render.InitRender();

    glutDisplayFunc(display);
    glutIdleFunc(display);
    glutMainLoop();
return 0;
}
#endif  //linux

