//
// BSP_tool - botman's Half-Life BSP utilities
//
// (http://planethalflife.com/botman/)
//
//
// Copyright (C) 2001 - Jeffrey "botman" Broome
//
// modified by SamPlay
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
//
// See the GNU General Public License for more details at:
// http://www.gnu.org/copyleft/gpl.html
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

//#define MI_NOMODELS;

#ifdef WIN32
#include <windows.h>
#include <direct.h>
#else
#include <stdio.h>
#endif

#include "scriplib.h"

#include "halflifemods_ct.h"
#include "paklib.h"
#include "wadlib.h"

//extern   char spawnpoint[];
extern  char HalfLifeDir[];

#ifndef MI_NOMODELS
extern  int num_models;
extern  char model_classname[][64];
extern  char model_filename[][64];
#endif

#ifndef M_PATHSEP
#ifdef WIN32
#define M_PATHSEP "\\"
#else
#define M_PATHSEP "/"
#endif
#endif
//======================================================

HalfLifeMods_ct HalfLifeMods;
char HalfLifeMods_ct:: HalfLifeModsFE[256]="HalfLifeMods.cfg";

//====================================================
//-------------------------------------------------------
void HalfLifeMods_ct:: reset()
{
pModDir= 0;
HalfLifeDir[0] = 0;

//spawnpoint[0] = 0;
int index;
for (index = 0; index < MAX_MODS; index++)
   mods[index]. clear();

num_mods= 0;
bsp_mod_index= -1;
valve_mod_index= -1;

#ifndef MI_NOMODELS
num_models = 0;
for(index = 0; index < MAX_MODELS; index++)
   {
   model_classname[index][0] = 0;
   model_filename[index][0] = 0;
   }
#endif
}
//-------------------------------------------------------
int HalfLifeMods_ct:: init( char *HalfLifeModsFE_i)
{
reset();

char HalfLifeModsPFE_a[MAX_PATH];
_getcwd(HalfLifeModsPFE_a, MAX_PATH);
strcat(HalfLifeModsPFE_a, M_PATHSEP);
strcat(HalfLifeModsPFE_a, HalfLifeModsFE_i);

::LoadScriptFile(HalfLifeModsPFE_a);
this-> ParseScriptFile();
if (valve_mod_index == -1)
	{
	Error("Can't find Half-Life\\valve directory!\n");
	return 1;
	}
return 0;
}
//----------------------------------------------------------
HalfLifeMods_ct::~HalfLifeMods_ct(void)
{
for(int index = 0; index < MAX_MODS; index++)
   mods[index]. clear();
}
//-----------------------------------------------
void modconfig_t:: clear()
	{
	pakconfig_t *pPakConfig;
	while( pPakConfig= pPak)
      {
      pPak = pPak-> next_config;
      fclose( pPakConfig->pakhandle);
      delete pPakConfig;
      }
 	wadconfig_t *pWadConfig;
	while(pWadConfig= pWad)
      {
      pWad = pWad->next_config;
      fclose(pWadConfig->wadhandle);
      delete pWadConfig;
      }
	}
//-------------------------------------------------------------
HANDLE FindDirectory(HANDLE hFile, CHAR *dirname, CHAR *filename)
{
WIN32_FIND_DATA pFindFileData;
dirname[0] = 0;
if (hFile == NULL)
   {
   hFile = FindFirstFile(filename, &pFindFileData);
   if (hFile == INVALID_HANDLE_VALUE)
      hFile = NULL;
   while (!(pFindFileData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY))
      {
      if (FindNextFile(hFile, &pFindFileData) == 0)
         {
         FindClose(hFile);
         hFile = NULL;
            return hFile;
         }
      }
   strcpy(dirname, pFindFileData.cFileName);
   return hFile;
   }
else
   {
   if (FindNextFile(hFile, &pFindFileData) == 0)
      {
      FindClose(hFile);
      hFile = NULL;
      return hFile;
      }
   while (!(pFindFileData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY))
      {
      if (FindNextFile(hFile, &pFindFileData) == 0)
         {
         FindClose(hFile);
         hFile = NULL;
         return hFile;
         }
      }

   strcpy(dirname, pFindFileData.cFileName);
   return hFile;
   }
}
//----------------------------------------------
HANDLE FindFile(HANDLE hFile, CHAR *file, CHAR *filename)
{
	WIN32_FIND_DATA pFindFileData;
	if (hFile == NULL)
		{
		 hFile = FindFirstFile(filename, &pFindFileData);
		if (hFile == INVALID_HANDLE_VALUE)
			hFile = NULL;
		}	
	else
		{
		if (FindNextFile(hFile, &pFindFileData) == 0)
			{
         FindClose(hFile);
         hFile = NULL;
			}
		}
	if (hFile != NULL)
		strcpy(file, pFindFileData.cFileName);
	return hFile;
}
//-------------------------------------------------------
void HalfLifeMods_ct::AddPakFile(int mod_index, char *pakfilename)
{
   FILE        *pakhandle;
   pakheader_t  pakheader;
   pakconfig_t *pPakConfig;
   int num_entries;
   int size;

   pakhandle = P_OpenPak(pakfilename);
   if (!P_ReadPakHeader(pakhandle, &pakheader))
		{
      fclose(pakhandle);
      return;
		}
   num_entries = pakheader.dir_length / sizeof(pakinfo_t);
   size = num_entries * sizeof(pakinfo_t);
   if (pakheader.dir_length != size)
      return;  // dir_length NOT even multiple of pakinfo size

   pPakConfig = new pakconfig_t(pakhandle, pakheader, num_entries) ;
   pPakConfig->next_config = mods[mod_index].pPak;   mods[mod_index].pPak = pPakConfig;
   P_ReadPakInfo(pakhandle, pakheader.dir_offset, num_entries, pPakConfig->pakinfo);
}
//--------------------------------------------
void HalfLifeMods_ct::AddWadFile(int mod_index, char *wadfilename_i)
	{
   FILE        *wadhandle;
   wadinfo_t    wadinfo;
   wadhandle = W_OpenWad(wadfilename_i);
   if (!W_ReadWadHeader(wadhandle, &wadinfo))
	   {
      fclose(wadhandle);
      return;
		}
   wadconfig_t *pWadConfig = new wadconfig_t( wadhandle, wadinfo);
   pWadConfig->next_config = mods[mod_index].pWad;   mods[mod_index].pWad = pWadConfig;
   W_ReadWadLumps(wadhandle, wadinfo.infotableofs, wadinfo.numlumps, pWadConfig->lumpinfo);
	}
//--------------------------------------------------------------------
void HalfLifeMods_ct::AddHalfLifeDir(char *HalfLifeDir_i)
	{
#ifdef WIN32
   HANDLE hDir;
   HANDLE hFile;
#endif
   char dirspec[256];
   char dirname[256];
   char filespec[256];
   char filename[256];
   char pakfilename[256];

   strcpy(dirspec, HalfLifeDir_i);
#ifndef __linux__
   strcat(dirspec, M_PATHSEP"*");
#else
   strcat(dirspec, M_PATHSEP"*");  //??? Linux dir wildcard
#endif

   hDir = NULL;

   while ((hDir = FindDirectory(hDir, dirname, dirspec)) != NULL)
		{
      if ((strcmp(dirname, ".") == 0) || (strcmp(dirname, "..") == 0))
         continue;
		sprintf(	filename,"%s%s%s%s", HalfLifeDir_i, M_PATHSEP, dirname, M_PATHSEP"liblist.gam");
      // is this a MOD directory? (i.e. does "liblist.gam" exist?)...
		if (FileTime(filename) != -1)
			{
			if (stricmp(dirname, "valve") == 0)
				valve_mod_index= num_mods;

			sprintf(mods[num_mods].dir, "%s%s%s%s",HalfLifeDir_i, M_PATHSEP, dirname, M_PATHSEP);

         // search for PAK files...
			hFile = NULL;
			strcpy(filespec, mods[num_mods].dir);
			strcat(filespec, "*.pak");

			while ((hFile = FindFile(hFile, filename, filespec)) != NULL)
				 {
				strcpy(pakfilename, mods[num_mods].dir);
            strcat(pakfilename, filename);
            AddPakFile(num_mods, pakfilename);
				}

			num_mods++;
			if (num_mods == MAX_MODS)
            Error("You have WAY too many MODs!");
			}
		}
	}
//---------------------------------------------------------
int  HalfLifeMods_ct::ParseScriptFile(void)
{
while (1)
   {
   do
      {
      GetToken (true);  // look for a line starting with a '$'
      if (endofscript)
         return 0;  // indicate success
      if (token[0] == '$')
         break;
      while (TokenAvailable())
         GetToken (false);
      } while (1);
/*
  if (strcmp(token, "$spawnpoint") == 0)
      {
      if (spawnpoint[0])
         Error("multiple $spawnpoint found in .cfg file!\n");
      GetToken(false);
      sscanf(token, "%s", spawnpoint);
      }
   else */
	if (strcmp(token, "$halflife_dir") == 0)
      {
      GetToken(false);
      if (FileTime(token) == -1)
         Error("Half-Life directory %s doen't exist\nPlease edit the .cfg file to match your installation\n", token);
      strcpy(HalfLifeDir, token);
      AddHalfLifeDir(token);
      }
#ifndef MI_NOMODELS
   else if (strcmp(token, "$models") == 0)
      {
      GetToken(true);
      if (strcmp(token, "{") != 0)
            Error("{ not found after $models tag in .cfg file!\n");
      while (1)
         {
         GetToken(true);  // get the entity name
         if (endofscript)
            Error("matching } not found after $models { in .cfg file!\n");

         if (strcmp(token, "}") == 0)
            break;

         strcpy(model_classname[num_models], token);

         GetToken(false);  // get the model filename

         if (strcmp(token, "}") == 0)
               Error("closing } found where model filename expected in .cfg file!\n");

         strcpy(model_filename[num_models], token);

         if (num_models < MAX_MODELS-1)
            num_models++;
         }
      }
#endif
   else
      Error("Unknown Config file option: %s\n", token);
   }
}
//-----------------------------------------------------------
// open a file by searching MOD directories first, then PAK files...
FILE *HalfLifeMods_ct::OpenMODFile(char *filename)
{
FILE *fp;
char filepath[256];
int mod_index;

   // is the MOD directory known from the BSP file?
if (bsp_mod_index >= 0)
   {
   strcpy(filepath, mods[bsp_mod_index].dir);
   strcat(filepath, filename);
   if (FileTime(filepath) != -1)  // does this wad file exist?
      {
      if ((fp = fopen(filepath, "rb")) == NULL)
         Error("Error opening file: %s\n", filepath);
      return fp;
      }
   }

   // use the valve directory by default...
strcpy(filepath, mods[valve_mod_index].dir);
strcat(filepath, filename);

if (FileTime(filepath) != -1)  // does this wad file exist?
   {
   if ((fp = fopen(filepath, "rb")) == NULL)
      Error("Error opening file: %s\n", filepath);
   return fp;
   }

   // if the MOD directory is known and not found so far, return error
if (bsp_mod_index >= 0)
   return NULL;

   // search ALL of the MOD directories for this wad file...
for (mod_index = 0; mod_index < num_mods; mod_index++)
   {
   strcpy(filepath, mods[mod_index].dir);
   strcat(filepath, filename);

   if (FileTime(filepath) != -1)  // does this wad file exist?
      {
      if ((fp = fopen(filepath, "rb")) == NULL)
         Error("Error opening file: %s\n", filepath);
      return fp;
      }
   }
return NULL;  // file not found!
}
//---------------------------------------------------------------
void HalfLifeMods_ct::getbsp_mod_index( char * bspname_i)
{
char pathname_a[256];
char modname_a[256];
int  len_a;

     // is this BSP file in a MOD directory?
ExtractFilePath( bspname_i, pathname_a);
len_a= strlen( pathname_a);  // remove trailing '/'
if( len_a > 0)
    pathname_a[ len_a- 1] = 0;
if( pathname_a[0]!= 0)
	{
   ExtractFileBase ( pathname_a, modname_a);
   if( stricmp( modname_a, "maps") == 0)
		{
      ExtractFilePath ( pathname_a, modname_a);
      if( modname_a[0]!= 0)
			{
         for (int i= 0; i< num_mods; i++)
            {
            if (stricmp(modname_a, mods[i].dir)== 0)
					{
					bsp_mod_index= i;
					break;
					}
				}
			}
		}
	}
}
