#ifndef BSP_EXT_H_
#define BSP_EXT_H_

#include "bspfile2.h"
#include "winding_ct.h"

#include "u_RzbVector_ctpl.h"
//+++++++++++++++++++++++++++++++++++
struct PlaneOrient_st
{
int PlaneNum;
int Side; 
	PlaneOrient_st(): PlaneNum( -1), Side( -1) {}
	PlaneOrient_st(int PlaneNum_i,int Side_i): PlaneNum( PlaneNum_i), Side( Side_i) {}
};
//++++++++++++++++++++++++++++++++++++++++++
class LeafBound_ct
{
public:
	//+++++++++++++++++++++++++++++++
	class Ctnr_ct: public RszVector_cT<LeafBound_ct *, 100>
	{
	public:
		Ctnr_ct() {  }
		~Ctnr_ct()
			{
			for(int i=0; i< size(); i++)
				delete (*this)[i];
			}
		LeafBound_ct * create()
			{
			LeafBound_ct * p= new LeafBound_ct;
			push_back( p);
			return p;
			} 
	};
	//eo Ctnr_ct++++++++++++++++++++++++++++++

	dplane_t	     plane;
	dnode_t		* GenNode;		// NULL = outside box
	short   		  NodeIds[ 2];   // [0] = front side of plane
	LeafBound_ct	* pNexts[ 2];	
	Winding_ct	* winding;

	LeafBound_ct(): GenNode(NULL), winding(NULL)
		{ 
		NodeIds[ 0]=NodeIds[ 1]=-1;
		pNexts[ 0]=pNexts[ 1]=0;
		}

	~LeafBound_ct() { delete winding;}

	int PlaneId_() { return GenNode? GenNode-> planenum: -1; }
	void copyAsDividedFrom( const LeafBound_ct & Bound_i)
		{
		plane= Bound_i.plane;
		GenNode= Bound_i.GenNode;
		NodeIds[ 0]= Bound_i.NodeIds[ 0];
		NodeIds[ 1]= Bound_i.NodeIds[ 1];
//		pNexts[ 0]= Bound_i.pNexts[ 0];	
//		pNexts[ 1]= Bound_i.pNexts[ 1];	
		}

	static LeafBound_ct * create()
		{
		LeafBound_ct * p= new LeafBound_ct;
		Ctnr. push_back( p);
		return p;
		} 

	static Ctnr_ct Ctnr;
};
typedef RszVector_cT<LeafBound_ct *, 100>  BoundLists_ct;
//+++++++++++++++++++++++++++++++++++++++
class HLBspFileExtsn_ct
{
public:
unsigned int          * FaceFlags;
HLBspFile_ct * pHLBspFile;
BoundLists_ct LeafBoundLists;//list of first Bounds of leafs
 
	HLBspFileExtsn_ct(): pHLBspFile(0) 
		{  init(); 
		}
	~HLBspFileExtsn_ct() 
		{  clear(); 
		}
protected:
	void clear()
		{  
		if( FaceFlags)
			delete[] FaceFlags;
		}
	void init()
		{
		FaceFlags= NULL;
		}

public:
	int  calcBspFileFaceFlags();
	void buildBspFileLeafBounds();

	int  getLeafBoundingPlanes( int LeafIndex_a, PlaneOrient_st * & PlaneIds_o);
	int  getLeafBoundingPlanes( const dleaf_t & Leaf_a, PlaneOrient_st * & PlaneIds_o);
//	int  getChebyCenter( int LeafNum_i, Vector & Center_i, float & Radius_i);

};

#endif //eof