// bv_Hud.cpp by SamPlay
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
//
// See the GNU General Public License for more details at:
// http://www.gnu.org/copyleft/gpl.html
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#include "appgene.h"
#include "gr_utilTextBox.h"
#include "camera.h"

#include "entity.h"
#include "bsp_ext.h"
#include "WorldRender_ct.h"
#include "DisplayOption_ct.h"
#include "console_ct.h"
#include "bsptrace.h"

extern Camera_ct Camera;
extern WorldRender_ct WorldRndr;
//extern BspMoveRender_ct BspMoveRndr;
extern Csl_ct Console;

extern HLBspFile_ct HLBspFile;
extern HLBspFileExtsn_ct BspExtsn;

extern bool_t  bEnable_noclip;
extern float frames_per_second;
extern int   rendered;
extern entvars_t entvars[];

extern TraceData_st DispTraceData;
extern Trace_ct DispTrace;

extern DisplayOption_ct DispOpt;


int getLeafFacePlanes( HLBspFile_ct * pHLBspFile_i, const dleaf_t & Leaf_a, int * & PlaneNums_a);
char * getTextureName( HLBspFile_ct * pHLBspFile_i, dface_t * pFace_i);
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
int bDisplayDbgMsg= 1;
//++++++++++++++++++++++++++
class TB_Gene_ct: public TextBox_ct
{
public:
	TB_Gene_ct(int boxL, int boxR, int boxT, int boxB
		, int r= 255, int g= 255, int b= 255, int a= 255
		, int Size_i= MAX_STR)
		:TextBox_ct( boxL, boxR, boxT, boxB, r,g,b,a,Size_i)
		{}
	void update();
};
//++++++++++++++++++++++++++
class TB_Dbg_ct: public TextBox_ct
{
public:
	TB_Dbg_ct(int boxL, int boxR, int boxT, int boxB
		, int r= 255, int g= 255, int b= 255, int a= 255
		, int Size_i= MAX_STR)
		:TextBox_ct( boxL, boxR, boxT, boxB, r,g,b,a,Size_i)
		{}
	void update();
};
//++++++++++++++++++++++++++
class TB_Console_ct: public TextBox_ct
{
public:
	TB_Console_ct(int boxL, int boxR, int boxT, int boxB
		, int r= 255, int g= 255, int b= 255, int a= 255
		, int Size_i= MAX_STR)
		:TextBox_ct( boxL, boxR, boxT, boxB, r,g,b,a,Size_i)
		{}
	void update();
};
//++++++++++++++++++++++++++
class TB_Trace_ct: public TextBox_ct
{
public:
	TB_Trace_ct(int boxL, int boxR, int boxT, int boxB
		, int r= 255, int g= 255, int b= 255, int a= 255
		, int Size_i= 255)
		:TextBox_ct( boxL, boxR, boxT, boxB, r,g,b,a,Size_i)
		{}
	void update();
};
//++++++++++++++++++++++++++
class TB_CurrLeaf_ct: public TextBox_ct
{
public:
	TB_CurrLeaf_ct(int boxL, int boxR, int boxT, int boxB
		, int r= 255, int g= 255, int b= 255, int a= 255
		, int Size_i= 255)
		:TextBox_ct( boxL, boxR, boxT, boxB, r,g,b,a,Size_i)
		{}
	void update();
};
//++++++++++++++++++++++++++
class TB_Entity_ct: public TextBox_ct
{
public:
	TB_Entity_ct(int boxL, int boxR, int boxT, int boxB
		, int r= 255, int g= 255, int b= 255, int a= 255
		, int Size_i= 255)
		:TextBox_ct( boxL, boxR, boxT, boxB, r,g,b,a,Size_i)
		{}
	void update();
};
const int K_CH= TextBox_ct:: FONT_DRAW_H;
const int	K_DyG= K_CH;
const int	K_DyT= 5* K_CH;
const int	K_DyC= 2* K_CH;
const int	K_DyE= 2* K_CH;
const int	K_DyL= 15* K_CH;

const int	K_yT= /*2**/ K_CH;
const int	K_yC= K_yT+ K_DyT;
const int	K_yE= K_yC+ K_DyC;
const int	K_yL= K_yE+ K_DyE;
const int	K_yd= K_yL+ K_DyL;

static TB_Gene_ct        TB_Gene(0, 640, 0, 200, 255, 255, 255, 255   , 1024);
static TB_Console_ct     TB_Console(0, 640, K_yC, 200, 255, 0, 255, 255   , 255);
static TB_Entity_ct      TB_Entity(0, 640, K_yE, 480-K_yE, 255, 255, 0, 255 , 255);
static TB_CurrLeaf_ct    TB_CurrLeaf(0, 640, K_yL, 480-K_yL, 255, 255, 0, 255 , 255);
static TB_Trace_ct     TB_Trace(0, 640, K_yT, 480-K_yT, 255, 255, 0, 255 , 255);
static TB_Dbg_ct         TB_Dbg(0, 640, K_yd, 480-K_yd, 255, 192, 0, 255, 1024);

static TextBox_ct * pHudElem_Tab_1[]=
	{
	& TB_Gene,
	& TB_Console,
	& TB_CurrLeaf,
	& TB_Entity,
	& TB_Trace,
	& TB_Dbg,
	};
static Hud_ct Hud1( pHudElem_Tab_1, sizeof(pHudElem_Tab_1)/sizeof(TextBox_ct *));

static HudMngr_ct HudMngr_s;
Hud_ct * HudMngr_ct:: Huds_s[]=
	{
	& Hud1,
	};
static int HudTabSize= sizeof(HudMngr_ct:: Huds_s)/sizeof(Hud_ct *);

//=================================
//-----------------------------------------
void Hud_init(/*int bOrthoIsSet_i*/)
{
//HudMngr_s. init( bOrthoIsSet_i);

//TB_Gene. setMode( TextBox_ct:: TEXT_DRAW_BOX);
TB_Gene. setMode( TextBox_ct:: TEXT_DRAW_BACKGROUND| TextBox_ct:: TEXT_DRAW_SPACES);
TB_Gene. setPrintVertDir( TextBox_ct:: TEXT_PRINTD_DOWN); 
TB_Gene. bIsToBeDrawn= 1;

TB_Console. setMode( TextBox_ct:: TEXT_DRAW_BACKGROUND| TextBox_ct:: TEXT_DRAW_SPACES);
TB_Console. setPrintVertDir( TextBox_ct:: TEXT_PRINTD_DOWN); 

TB_Trace. setMode( TextBox_ct:: TEXT_DRAW_BACKGROUND| TextBox_ct:: TEXT_DRAW_SPACES);
TB_Trace. setPrintVertDir( TextBox_ct:: TEXT_PRINTD_DOWN); 

TB_Entity. setMode( TextBox_ct:: TEXT_DRAW_BACKGROUND| TextBox_ct:: TEXT_DRAW_SPACES);
TB_Entity. setPrintVertDir( TextBox_ct:: TEXT_PRINTD_DOWN); 

TB_CurrLeaf. setMode( TextBox_ct:: TEXT_DRAW_BACKGROUND| TextBox_ct:: TEXT_DRAW_SPACES);
TB_CurrLeaf. setPrintVertDir( TextBox_ct:: TEXT_PRINTD_DOWN); 
TB_CurrLeaf. bIsToBeDrawn= 1;

TB_Dbg. setMode( TextBox_ct:: TEXT_DRAW_BACKGROUND| TextBox_ct:: TEXT_DRAW_SPACES);
TB_Dbg. setPrintVertDir( TextBox_ct:: TEXT_PRINTD_DOWN); 
}
//-----------------------------------------
void Hud_update()
{
HudMngr_s. pCurrHud_s_()-> update();
TB_CurrLeaf. bIsToBeDrawn= 1;
TB_Trace. bIsToBeDrawn= WorldRndr. bTraceAvail;
TB_Entity. bIsToBeDrawn= (WorldRndr. DrawEntities==2);
TB_Dbg. bIsToBeDrawn= bDisplayDbgMsg;
}
//------------------------------------------------
void draw2DHud( int bIsOrthoSet_i)
{
HudMngr_s. draw_s( bIsOrthoSet_i);
}
//----------------------------------
void TB_Gene_ct :: update()
{
clear();
if( !bIsToBeDrawn)
	return;

char c_clip[4];
if (bEnable_noclip)
	strcpy(c_clip, "OFF");
else
	strcpy(c_clip, "ON ");

//copyadd("FPS: %4.1f  Polygons Rendered: %4d\n",frames_per_second, rendered);
float yaw_a=-Camera. yaw()+90;
if( yaw_a>0)
	{
	while( yaw_a>=360.0f) { yaw_a-= 360.0f;}
	}
else
	{
	while( yaw_a< 0.0f) { yaw_a+= 360.0f;}
	}

copyadd("CAM x=%7.1f y=%7.1f z=%7.1f  yaw=%5.1f  pitch=%5.1f  clip: %s\n"
	,  Camera. eye()[0], Camera. eye()[1], Camera. eye()[2]
	,  yaw_a, -Camera.pitch()- 90
	, c_clip);
}
//----------------------------------
void TB_Console_ct :: update()	
	{
	clear();
	if( Console.bConsoleMode)
		{
		copyadd("CONSOLE: %s", Console. ConsoleTxt);
		addLineFeed();
		copyadd("CONSMSG: %s", Console. ConsoleMsg);
		}
	}
//----------------------------------
void TB_Trace_ct :: update()
	{
	clear();
	if( !bIsToBeDrawn)
		return;
	
   float HitDist_a=DispTraceData. HitDist;
	char TType_a[128];
	
	dplane_t *pPlane_a = & HLBspFile. dplanes[ DispTraceData. planenum];
	if( DispTrace. Type== Trace_ct::K_Point)
		{
		sprintf( TType_a,"POINT");
		}
	else if( DispTrace. Type== Trace_ct::K_AABox)
		{
		sprintf( TType_a,"AABOX [ %4.0f %4.0f %4.0f]"
			, DispTrace.XSize_(), DispTrace.YSize_(), DispTrace.Height_());
		}
	else if( DispTrace. Type== Trace_ct::K_AACylinder)
		{
		sprintf( TType_a,"AACYL [ r=%4.0f h=%4.0f]"
			, DispTrace.Radius_(), DispTrace.Height_());
		}
	else if( DispTrace. Type== Trace_ct::K_Sphere)
		{
		sprintf( TType_a,"SPHER [ r=%4.0f]", DispTrace. Radius_());
		}
	copyadd( "RAYTRACE: %s\n", TType_a);
	copyadd( "RAYTRACE: HitDist=%8.2f  Plane#%4i {n=(%5.2f %5.2f %5.2f), d=%7.1f}\n"
			, HitDist_a, DispTraceData. planenum
			, pPlane_a-> normal[0], pPlane_a-> normal[1], pPlane_a-> normal[2], pPlane_a-> dist);
			 
	if( DispTraceData. fraction==0.0f)
		{
		copyadd( "RAYTRACE: StartLeaf#%4i (Contents=%2i)=> Trace stops dead\n"
			"RAYTRACE: Frac %7.5f  \n"
			, DispTraceData. StartLeafNum, DispTraceData. StartContents
			, DispTraceData. fraction
			);
		}
	else
		{
		copyadd( "RAYTRACE: StartLeaf#%4i (Contents=%2i) LastLeaf#%4i EndLeaf#%4i (Contents=%2i)\n"
			"RAYTRACE: Frac %7.5f Endpos(%8.2f %8.2f %8.2f)\n"
			, DispTraceData. StartLeafNum, DispTraceData. StartContents
			, DispTraceData. FurthestNonBlockingLeafNum
			, DispTraceData. BlockingLeafNum , DispTraceData. contents
			, DispTraceData. fraction
			, DispTraceData. endpos[0], DispTraceData. endpos[1], DispTraceData. endpos[2]
			);
		if( DispTraceData. FaceNum>= 0)
			{
			dface_t * pFace_a= & HLBspFile. dfaces[DispTraceData. FaceNum];
			char * TextureName_a= getTextureName( & HLBspFile, pFace_a);
			if( !TextureName_a)
				TextureName_a="";
			copyadd( "RAYTRACE: HitFace#%4i  FacePlane#%4i/%i IsWalkable=%1i Texture=%s"
				, DispTraceData. FaceNum
				, pFace_a->planenum, pFace_a->side
				, (::BspExtsn. FaceFlags[DispTraceData. FaceNum] & KB_FD_Walkable), TextureName_a);
			}
		}
}
//----------------------------------
void TB_Entity_ct :: update()
{
clear();
if( !bIsToBeDrawn)
	return;
copyadd("entity #%i classname=%s\n", WorldRndr. FocusEntIdx
	, entvars[WorldRndr. FocusEntIdx].classname);
}
//----------------------------------
void TB_CurrLeaf_ct :: update()
{
clear();
if( !bIsToBeDrawn)
	return;

if( !DispOpt. pHLBspFileForInfo)
	return;
WorldRender_ct * pWRdr_a;
//if( DispOpt. pHLBspFileForInfo-> TypeFlag && HLBspFile2_ct:: K_BS_Mov)
//	{
//	pWRdr_a= & BspMoveRndr;
//	}
//else
//	{
	pWRdr_a= & WorldRndr;
// }

if( pWRdr_a->bTraceAvail)
	SetColor4i( 255, 255, 0, 255);
else
	SetColor4i( 255, 255, 255, 255);
	

if( !pWRdr_a-> pHLBspFile || pWRdr_a-> FocusLeafId<0)
	return;

const dleaf_t &Leaf_a= pWRdr_a-> pHLBspFile-> dleafs[ pWRdr_a-> FocusLeafId];

copyadd(" Leaf#= %d  contents= %d\n"
	, pWRdr_a-> FocusLeafId, Leaf_a.contents);


PlaneOrient_st * OrPlanes_a=0;
int Count_a= BspExtsn. getLeafBoundingPlanes( pWRdr_a-> FocusLeafId, OrPlanes_a);
int i=0;
while(i< Count_a)
	{
	dplane_t * pPlane_a= & pWRdr_a-> pHLBspFile-> dplanes[ OrPlanes_a[ i]. PlaneNum];
	copyadd("  BndgPln= %5i/%1i  Norm= %6.2f %6.2f %6.2f d=%5.0f \n"
		, OrPlanes_a[ i]. PlaneNum, OrPlanes_a[ i]. Side
		, pPlane_a-> normal[ 0], pPlane_a-> normal[ 1], pPlane_a-> normal[ 2], pPlane_a->dist );
	++i;
	}
delete[] OrPlanes_a;

/*
	//_ planes with >=1 face on it
int * PlaneIds_a= 0;
int Count_a= getLeafFacePlanes( pWRdr_a-> pHLBspFile, Leaf_a, PlaneIds_a);
int i=0;
while(i< Count_a)
	{
	dplane_t * pPlane_a= & pWRdr_a-> pHLBspFile-> dplanes[ PlaneIds_a[ i]];
	copyadd("  BndgPln= %5i Nrm= %6.2f %6.2f %6.2f d=%5.0f\n"
		, PlaneIds_a[ i]
		, pPlane_a-> normal[ 0], pPlane_a-> normal[ 1], pPlane_a-> normal[ 2], pPlane_a-> dist );
	++i;
	}
delete []PlaneIds_a;
*/
}
int DbgDisplay_s;
//----------------------------------
void TB_Dbg_ct :: update()
{
}
//------------------------------------------
void affDbgMsg (unsigned int i, char *Txt_i, ...)
{
static int DbgDisplay_s;
DbgDisplay_s= i;
TB_Dbg. clear();

if(Txt_i)
	{
	TB_Dbg. copyadd("<hit 'm' to clear>"); //TB_Dbg. addLineFeed();
	DbgDisplay_s= 1;
	
   va_list argptr;
   char msg[256];

   va_start (argptr, Txt_i);
   vsprintf (msg, Txt_i, argptr);
   va_end (argptr);
	TB_Dbg. copyadd(Txt_i); TB_Dbg. addLineFeed();
	}
/*
if( DbgDisplay_s==0 || !Txt_i)
	TB_Dbg. clear();
else
	{
	DbgDisplay_s= 1;
	
   va_list argptr;
   char msg[256];

   va_start (argptr, Txt_i);
   vsprintf (msg, Txt_i, argptr);
   va_end (argptr);
	TB_Dbg. copyadd(Txt_i); TB_Dbg. addLineFeed();
	}
*/
}