// bv_displays.cpp by SamPlay
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
//
// See the GNU General Public License for more details at:
// http://www.gnu.org/copyleft/gpl.html
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#include "appgene.h"
#include "render.h"
#include "matrix.h"

#include "bspfile2.h"
#include "camera.h"
#include "sys_time.h"
#include "entity.h"
#include "world_ct.h"
#include "bsptrace.h"

//extern Camera_ct       Camera;
extern bool_t bDrawTraceline;
//extern vec3_t traceline_pt[];

extern int ScreenCenterX;
extern int ScreenCenterY;
//-------------------------------------------
void draw2DCrosshair(void)
{
glEnable(GL_LINE_SMOOTH);  // more visible, but a lot slower
glLineWidth(1.0f);

glColor3f (1.0f, 0.7f, 0.01f);  // Half-Life orangish

glBegin (GL_LINES);
 glVertex2i(ScreenCenterX, ScreenCenterY - 10);
 glVertex2i(ScreenCenterX, ScreenCenterY + 10);
glEnd ();

glBegin (GL_LINES);
 glVertex2i(ScreenCenterX - 10, ScreenCenterY);
 glVertex2i(ScreenCenterX + 10, ScreenCenterY);
glEnd ();

glDisable(GL_LINE_SMOOTH);
glColor3f (1.0f, 1.0f, 1.0f);  // back to white
}
//--------------------------------------------------------
void drawTraceline( vec3_t traceline_pt[3])
{
glPointSize (10.0f);  // big dot
glColor3f (1.0f, 0, 1.0f);  // draw hit point in red

glBegin (GL_POINTS);
 glVertex3f (traceline_pt[0][0], traceline_pt[0][1], traceline_pt[0][2]);
 glVertex3f (traceline_pt[2][0], traceline_pt[2][1], traceline_pt[2][2]);
glEnd ();

glEnable(GL_LINE_SMOOTH);  // more visible, but a lot slower
glLineWidth(1.0f);

glColor3f (0.0f, 1.0f, 0.0f);  // draw line in red

glBegin (GL_LINES);
 glVertex3f (traceline_pt[0][0], traceline_pt[0][1], traceline_pt[0][2]);
 glVertex3f (traceline_pt[1][0], traceline_pt[1][1], traceline_pt[1][2]);
glEnd ();

glColor3f (1.0f, 0.0f, 0.0f);  // draw line in red
glBegin (GL_LINES);
 glVertex3f (traceline_pt[0][0], traceline_pt[0][1], traceline_pt[0][2]);
 glVertex3f (traceline_pt[2][0], traceline_pt[2][1], traceline_pt[2][2]);
glEnd ();
glDisable(GL_LINE_SMOOTH);
glColor3f (1.0f, 1.0f, 1.0f);  // back to white
}
/*
//---------------------------------------
void drawTranspPane( vec3_t Coords_i[4], float R, float G, float B, int bRev_i)
{
glEnable(GL_BLEND);
glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
glColor4f( R, G, B, 0.7f);

glBegin (GL_POLYGON);
int i;
for (i=0 ; i< 4; i++)
	glVertex3f (Coords_i[i][0], Coords_i[i][1], Coords_i[i][2]);
glEnd ();
glFlush ();

glDisable(GL_BLEND);
glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
}
*/

/*
//---------------------------------------------------------------
void print_textCenter( char *text)
{
int x, y, len;
x= config.width/ 2;
y= config.height/ 2;
   // rescale X and Y to keep text center regardless of screen size...
if (config.width< 800)
	x= x * (800.0f / (float)config.width);
if (config.height< 600)
   y= y * (600.0f/ (float)config.height);
   // center text on screen (down slightly from center)
len = strlen(text);
x= x- len * 8;  // each char is 16 units wide
y= y- 32;
print_text( x, y, text);
}
*/
