#ifdef _WIN32
#pragma once
#endif
#ifndef UTIL_3DOBJECTS_H
#define UTIL_3DOBJECTS_H

#include "gr_utilModels_ct.h"

typedef float (*fct_Z_xy_pft)(float x_i, float y_i);
//
//+++++++++++++++++++++++++++++++++++++++++++
class Cone2_ct
{
public:
ConeModel_ct * pModel;
static ConeModel_ct ConeModel_s;
float Srcex;
float Srcey;
float Srcez;
float Destx;
float Desty;
float Destz;
	Cone2_ct( ConeModel_ct * pModel_i= 0/*NULL*/, float Srcex_i=0.0f, float Srcey_i=0.0f, float Srcez_i=0.0f,
		float Destx_i=1.0f, float Desty_i=1.0f, float Destz_i=1.0f);
	void draw()
		{	pModel-> draw( Srcex, Srcey, Srcez, Destx, Desty, Destz);
		} 
};
//+++++++++++++++++++++++++++++++++++++++++++
class Cylinder2_ct
{
public:
CylinderModel_ct * pModel;
static CylinderModel_ct CylinderModel_s;
float Srcex;
float Srcey;
float Srcez;
float Destx;
float Desty;
float Destz;
	Cylinder2_ct( CylinderModel_ct * pModel_i= 0, float Srcex_i=0.0f, float Srcey_i=0.0f, float Srcez_i=0.0f,
		float Destx_i=1.0f, float Desty_i=1.0f, float Destz_i=1.0f);
	void draw( unsigned DrawFlags_i= KB_Solid)
		{	pModel-> draw( pModel-> r, Srcex, Srcey, Srcez, Destx, Desty, Destz, DrawFlags_i);
		} 
};
//+++++++++++++++++++++++++++++++++++++++++++
class Arrow2_ct
{
public:
ArrowModel_ct * pModel;
static ArrowModel_ct ArrowModel_s;

unsigned int  Flags;
float Srcex;
float Srcey;
float Srcez;
float Destx;
float Desty;
float Destz;
	Arrow2_ct( unsigned int Flags_i= 0, ArrowModel_ct * pModel_i= 0/*NULL*/, float Srcex_i=0.0f, float Srcey_i=0.0f, float Srcez_i=0.0f,
		float Destx_i=1.0f, float Desty_i=1.0f, float Destz_i=1.0f);
	
	void draw( unsigned int Flags_i)
		{
		pModel->draw( Srcex, Srcey, Srcez, Destx, Desty, Destz, Flags_i);
		}
	void draw()
		{
		pModel->draw( Srcex, Srcey, Srcez, Destx, Desty, Destz, Flags);
		}
};
//+++++++++++++++++++++++++++++++++++++++++++
class Axes_ct
{
public:
AxesModel_ct * pModel;
static AxesModel_ct AxesModel_s;
int   bIsToBeDrawn;
float x;
float y;
float z;
	Axes_ct( AxesModel_ct * pModel_i= 0/*NULL*/, float x_i=0, float y_i=0, float z_i=0);
	void draw()  
		{ 
		if( bIsToBeDrawn)
			pModel-> draw( x,y,z);
		}
};
//+++++++++++++++++++++++++++++++++++++++++++
class Grid_ct
{
public:
GridModel_ct * pModel;
static GridModel_ct GridModel_s;
int   bIsToBeDrawn;
float x;
float y;
float z;
	Grid_ct( GridModel_ct * pModel_i= 0/*NULL*/, float x_i=0, float y_i=0, float z_i=0);
	void draw()  
		{ 
		if( bIsToBeDrawn)
			pModel-> draw( x,y,z);
		}
};
//+++++++++++++++++++++++++++++++++++++++++++
class LeveledGrid_ct: public GridModel_ct
{
public:
fct_Z_xy_pft eval;
float x;
float y;
float z; 
float * Val;
	LeveledGrid_ct(int Sidex_i=4000, int Sidey_i=4000, int Side_i=100);
	~LeveledGrid_ct(){ delete[]Val;}
	float & operator()( int i, int j){ return  Val[ j* Ny+ i];}
	void    draw();
	void    draw( float x_i, float y_i, float z_i);
	void    clearVal();
	int     recalc( void);
	void    recalc( fct_Z_xy_pft eval_i) {  eval= eval_i; recalc(); } 
};
#endif //EOF