#include <GL/glut.h>

#include "u_Gene.h"
#include "gr_utilModels_ct.h"
//#include "gr_utilFont.h"//for drawAxesNames( float x, float y, float z)

#include <cmath>
#include <memory>

//==========================================================
//----------------------------------------------------------
inline int isEqual(float a,float b) 
{
return(fabs(a-b) < K_Epsilonf) ;
}
/*
//-------------------------------------------
void coneOuverture(float dx_i,float dy_i,float dz_i,float a_i) 
{
float d_a = sqrt(dx_i*dx_i+dy_i*dy_i+dz_i*dz_i);
glPushMatrix();
 dx_i/= d_a; 
 dy_i/= d_a; 
 dz_i/= d_a;
 if( isEqual(dz_i,-1.0f) )
   glRotatef( 180.0f, 1.0f, 0.0f, 0.0f);
 else  if ( !isEqual(dz_i, 1.0f) ) 
	{
   float a= acos(dz_i)* 180/ M_PI;
   glRotatef(a_i, -dy_i, dx_i, 0); 
	}
 glPushMatrix();
  glRotatef( 90.0f, 1.0f, 0.0f, 0.0f);
  glRotatef( 180.0f, 0.0f, 0.0f, 1.0f);
  glTranslatef( 0.0f, -d_a*.5f, 0.0f);
  ConeModel_ct( 120, tan(a_i/180.0*M_PI)*d_a, d_a). draw();
 glPopMatrix();
glPopMatrix();
}
*/
//-------------------------------------------------
GridModel_ct:: GridModel_ct(int Sidex_i, int Sidey_i, int Side_i)
{
Side= Side_i;
Nx= 1+(Sidex_i/ Side);
Nx+= Nx^ 1;
Sidex= Side* (Nx-1);		
Ny= 1+(Sidey_i/ Side);
Ny+= Ny^ 1;
Sidey= Side* (Ny-1);		
setColor4f(1.0,1.0,1.0,0.3);
Offsetx= 0.5f* Sidex;
Offsety= 0.5f* Sidey;
} 
//-------------------------------------------
void GridModel_ct:: draw()
{
draw( 0.0f, 0.0f, 0.0f);
}
//------------------------------------------------------
void GridModel_ct:: draw( float x, float y, float z)
{
glPushMatrix();

 glTranslatef( x-Offsetx, y-Offsety, z);

 glLineWidth( 1);
 glColor4f(r,g,b,a);
 glEnable(GL_LINE_STIPPLE);
 glLineStipple(1,0x5555);

 float Coord_a;
 glBegin(GL_LINES);
 for( int i= 0; i< Nx; i++)
	{
	Coord_a= (float)i* Side;
	glVertex3f(Coord_a, 0.0f, 0.0f);
	glVertex3f(Coord_a, (float)Sidey, 0.0f);
	}
 for( int j= 0; j< Ny; j++)
	{
	Coord_a= (float)j* Side;
	glVertex3f(0.0f, Coord_a, 0.0f);
	glVertex3f((float)Sidex, Coord_a, 0.0f);
	}
 glEnd();
glPopMatrix();

glPushMatrix();
 glTranslatef( x, y, z);

 float Side_a= Side*.2;
 glBegin(GL_LINE_LOOP);
  glVertex3f(-Side_a, -Side_a, 0.01);
  glVertex3f( Side_a, -Side_a, 0.01);
  glVertex3f( Side_a,  Side_a, 0.01);
  glVertex3f(-Side_a,  Side_a, 0.01);
 glEnd();

 glDisable(GL_LINE_STIPPLE);
glPopMatrix();
}
/*
//-------------------------------------------
void GridModel_ct:: draw()
{
glPushMatrix();

 glTranslatef( x-Offsetx, y-Offsety, z);

 glLineWidth( 1);
 glColor4f(r,g,b,a);
 glEnable(GL_LINE_STIPPLE);
 glLineStipple(1,0x5555);

 float Coord_a;
 glBegin(GL_LINES);
 for( int i= 0; i< Nx; i++)
	{
	Coord_a= (float)i* Side;
	glVertex3f(Coord_a, 0.0f, 0.0f);
	glVertex3f(Coord_a, (float)Sidey, 0.0f);
	}
 for( int j= 0; j< Ny; j++)
	{
	Coord_a= (float)j* Side;
	glVertex3f(0.0f, Coord_a, 0.0f);
	glVertex3f((float)Sidex, Coord_a, 0.0f);
	}
 glEnd();
glPopMatrix();

glPushMatrix();
 glTranslatef( x, y, z);

 float Side_a= Side*.2;
 glBegin(GL_LINE_LOOP);
  glVertex3f(-Side_a, -Side_a, 0.01);
  glVertex3f( Side_a, -Side_a, 0.01);
  glVertex3f( Side_a,  Side_a, 0.01);
  glVertex3f(-Side_a,  Side_a, 0.01);
 glEnd();

 glDisable(GL_LINE_STIPPLE);
glPopMatrix();
}
*/
//----------------------------------------------
void CylinderModel_ct:: setNumOfSectors( int n_i)
{
clear();
n= n_i;
cs = new float[ n+1];
sn = new float[ n+1];
ncs = new float[ n+1];
nsn = new float[ n+1];

cs[0] = cs[n] = r ;
sn[0] = sn[n] = 0.0 ;
ncs[0] = ncs[n] = 1.0 ;
nsn[0] = nsn[n] = 0.0 ;

float a;
for ( int i = 1 ; i < n ; i++ ) 
	{
    a = M_PI/ n* 2* i;
    ncs[i] = cos(a) ;
    nsn[i] = sin(a) ;
	}
if( r!=0)
	setRadiusMax( r);
}
//----------------------------------------------
void CylinderModel_ct:: clear()
{
delete[]sn ;
delete[]cs ;
delete[]nsn ;
delete[]ncs ;
}
//----------------------------------------------
void CylinderModel_ct:: set( int n_i, float r_i, float h_i, int bDrawBases_i)
{
bDrawBases= bDrawBases_i;
h= h_i;
r= r_i;
setNumOfSectors( n_i);
}
//----------------------------------
void CylinderModel_ct:: setRadiusMax( float r_i)
{
r= r_i;
for ( int i = 1 ; i < n ; i++ ) 
	{
   cs[i] = r* ncs[i] ;
   sn[i] = r* nsn[i] ; 
	}
} 
//-----------------------------------------------
void CylinderModel_ct:: drawSolid() 
{
int i;
if( bDrawBases)
	{
	glBegin(GL_POLYGON);
		glNormal3f(0.0,1.0,0.0) ;
		for ( i = 0 ; i < n ; i++ ) 
 		glVertex3f(cs[i], h*.5,sn[i]); 
	glEnd() ;
	
glBegin(GL_POLYGON) ;
 glNormal3f(0.0,-1.0,0.0) ;
 for ( i = 0 ; i < n ; i++ ) 
	glVertex3f(cs[i], -h*.5,sn[i]); 
glEnd() ;
	}

glBegin(GL_QUADS) ;
 for ( i = 0 ; i < n ; i++ ) 
	{
    glNormal3f(ncs[i],0.0,nsn[i]) ;
    glVertex3f(cs[i],h*.5,sn[i]);
    glNormal3f(ncs[i+1],0.0,nsn[i+1]) ;
    glVertex3f(cs[i+1],h*.5,sn[i+1]);
    glVertex3f(cs[i+1],-h*.5,sn[i+1]);
    glNormal3f(ncs[i],0.0,nsn[i]) ;
    glVertex3f(cs[i],-h*.5,sn[i]); 
	}
glEnd() ;
}
//-----------------------------------------------
void CylinderModel_ct:: drawWF() 
{
int i;

glBegin(GL_LINE_LOOP);
for ( i= 0 ; i < n ; i++ ) 
	glVertex3f( cs[i], h*.5, sn[i]); 
glEnd() ;
	
glBegin(GL_LINE_LOOP) ;
for ( i= 0 ; i < n ; i++ ) 
	glVertex3f( cs[i], -h*.5, sn[i]); 
glEnd() ;

for ( i= 0 ; i < n ; i++ ) 
	{
	glBegin(GL_LINES) ;
   glVertex3f(cs[i],-h*.5,sn[i]); 
   glVertex3f(cs[i],h*.5,sn[i]);
	glEnd() ;
	}
}
/*
//------------------------------------------------
void CylinderModel_ct:: draw( float Srcex, float Srcey, float Srcez,
	float Destx, float Desty, float Destz, unsigned DrawFlags_i, int bUseModelLength_i) 
{
float dx_a= Destx- Srcex;
float dy_a= Desty- Srcey;
float dz_a= Destz- Srcez;
float d_a = sqrt(dx_a*dx_a+dy_a*dy_a+dz_a*dz_a);
dx_a/= d_a; 
dy_a/= d_a; 
dz_a/= d_a;
if( !bUseModelLength_i)
	h= d_a;

glPushMatrix();
 glTranslatef(Srcex,Srcey,Srcez);
 glPushMatrix();
  if ( isEqual(dz_a,-1.0f) )
    glRotatef(180.0f,1.0f,0.0f,0.0f);
  else if ( !isEqual(dz_a,1.0f) ) 
	{
   float ang = acos(dz_a) * 180/ M_PI;
   glRotatef( ang, -dy_a, dx_a, 0); 
	}
  glTranslatef( 0.0f, 0.0f, (float)h* 0.5f);
  glPushMatrix();
   glRotatef( 90.0f, 1.0f, 0.0f, 0.0f);
	if( DrawFlags_i & KB_WireFrame)
		drawWF();
	else
		drawSolid();
  glPopMatrix();
 glPopMatrix();
glPopMatrix();
}
*/
//------------------------------------------------
void CylinderModel_ct:: draw( float Radius_i, float Srcex, float Srcey, float Srcez,
	float Destx, float Desty, float Destz, unsigned DrawFlags_i, int bUseModelLength_i) 
{
float dx_a= Destx- Srcex;
float dy_a= Desty- Srcey;
float dz_a= Destz- Srcez;
float d_a = sqrt(dx_a*dx_a+dy_a*dy_a+dz_a*dz_a);
dx_a/= d_a; 
dy_a/= d_a; 
dz_a/= d_a;
if( !bUseModelLength_i)
	h= d_a;

glPushMatrix();
 glTranslatef(Srcex,Srcey,Srcez);
 glPushMatrix();
  if ( isEqual(dz_a,-1.0f) )
    glRotatef(180.0f,1.0f,0.0f,0.0f);
  else if ( !isEqual(dz_a,1.0f) ) 
	{
   float ang = acos(dz_a) * 180/ M_PI;
   glRotatef( ang, -dy_a, dx_a, 0); 
	}
  glTranslatef( 0.0f, 0.0f, (float)h* 0.5f);
  glPushMatrix();
   glRotatef( 90.0f, 1.0f, 0.0f, 0.0f);
	if( Radius_i!= r)
		{
		float Coeff_a= Radius_i/r;
		glScalef( Coeff_a, 1.0f, Coeff_a);//!!!not sure
		}
	if( DrawFlags_i & KB_WireFrame)
		drawWF();
	else
		drawSolid();
  glPopMatrix();
 glPopMatrix();
glPopMatrix();
}
//----------------------------------------------
ConeModel_ct:: ConeModel_ct( int n_i, float r_i, float h_i)
{
h= h_i;
r= r_i;
n= n_i;
cs = new float[ n+1];
sn = new float[ n+1];
ncs = new float[ n+1];
nsn = new float[ n+1];

cs[0] = cs[n] = r ;
sn[0] = sn[n] = 0.0 ;
ncs[0] = ncs[n] = 1.0 ;
nsn[0] = nsn[n] = 0.0 ;

float a;
for ( int i = 1 ; i < n ; i++ ) 
	{
    a = M_PI/n*2*i;
    ncs[i] = cos(a) ;
    nsn[i] = sin(a) ;
	}
if( r!=0)
	setRadiusMax( r);
}
//----------------------------------
void ConeModel_ct:: setRadiusMax( float r_i)
{
r= r_i;
for ( int i = 1 ; i < n ; i++ ) 
	{
   cs[i] = r* ncs[i] ;
   sn[i] = r* nsn[i] ; 
	}
} 
//----------------------------------------------
ConeModel_ct:: ~ConeModel_ct()
{
delete[]sn ;
delete[]cs ;
delete[]nsn ;
delete[]ncs ;
} 
//----------------------------------------------
void ConeModel_ct:: draw() 
{
int i;
glBegin(GL_POLYGON) ;
 glNormal3f(0.0,-1.0,0.0) ;
 for( i = 0 ; i < n ; i++ ) 
	{
   glVertex3f( cs[ i], -h* 0.5, sn[ i]); 
	}
 glEnd() ;
glBegin(GL_QUADS) ;
 for( i = 0 ; i < n ; i++ ) 
	{
   glNormal3f( ncs[ i], 0.0, nsn[ i]) ;
   glVertex3f( 0, h* 0.5, 0);
   glNormal3f( ncs[ i+ 1], 0.0, nsn[ i+ 1]) ;
   glVertex3f( 0, h* 0.5,0);
   glVertex3f( cs[ i+ 1], -h* 0.5, sn[ i+ 1]);
   glNormal3f( ncs[ i], 0.0, nsn[ i]) ;
   glVertex3f( cs[ i], -h* 0.5, sn[ i]); 
	}
glEnd() ;
}
//------------------------------------------------
void ConeModel_ct:: draw( float Srcex, float Srcey, float Srcez,
	float Destx, float Desty, float Destz, int bUseModelLength_i) 
{
float dx_a= Destx- Srcex;
float dy_a= Desty- Srcey;
float dz_a= Destz- Srcez;
float d_a = sqrt(dx_a*dx_a+dy_a*dy_a+dz_a*dz_a);
dx_a/= d_a; 
dy_a/= d_a; 
dz_a/= d_a;
if( !bUseModelLength_i)
	h= d_a;

glPushMatrix();
 glTranslatef(Srcex,Srcey,Srcez);
 glPushMatrix();
  if ( isEqual(dz_a,-1.0f) )
    glRotatef(180.0f,1.0f,0.0f,0.0f);
  else if ( !isEqual(dz_a,1.0f) ) 
	{
   float ang = acos(dz_a) * 180/ M_PI;
   glRotatef( ang,-dy_a, dx_a,0); 
	}
 glTranslatef(0.0f,0.0f,(float)h * 0.5); 
  glPushMatrix();
   glRotatef( 90.0f, 1.0f, 0.0f, 0.0f);
	draw();
  glPopMatrix();
 glPopMatrix();
glPopMatrix();
}
/*
//------------------------------------------------
void ArrowModel_ct:: setParam (float Srcex, float Srcey, float Srcez,
	float Destx, float Desty, float Destz,float cr_i,float cl_i,float ct_i)
{
float dx_a= Destx- Srcex;
float dy_a= Desty- Srcey;
float dz_a= Destz- Srcez;

Mdl= sqrt(dx_a*dx_a+dy_a*dy_a+dz_a*dz_a);
cr=cr_i;
cl=cl_i;
ct=ct_i;
Cone. n= 36;
Cone. r= cr_i;
Cone. h= cl_i;
Cylinder.n= 36;
Cylinder.r= ct_i;
Cylinder.h= Mdl- cl_i;
}
*/
//------------------------------------------------
ArrowModel_ct::ArrowModel_ct (float Length_i,float ConeRadius_i,float ConeLength_i,float CylRadius_i, unsigned Flags_i)
	: Length( Length_i), ConeRadius(ConeRadius_i), ConeLength( ConeLength_i), CylRadius(CylRadius_i)
	, ConeModel( 36, ConeRadius_i, ConeLength_i)
	, CylinderModel( 36, CylRadius_i, Length_i- ConeLength_i)
	, Flags( Flags_i)
{
}
//----------------------------------------------------
void ArrowModel_ct:: draw( float Srcex, float Srcey, float Srcez,	float Destx, float Desty, float Destz, unsigned DrawFlags_i)
{
if( DrawFlags_i & KB_WireFrame)
	drawWF( Srcex, Srcey, Srcez, Destx, Desty, Destz, DrawFlags_i);
else
	drawSolid( Srcex, Srcey, Srcez, Destx, Desty, Destz, DrawFlags_i);
}
//------------------------------------------------
void ArrowModel_ct:: drawSolid( float Srcex, float Srcey, float Srcez,
	float Destx, float Desty, float Destz, unsigned Flags_i) 
{
float dx_a= Destx- Srcex;
float dy_a= Desty- Srcey;
float dz_a= Destz- Srcez;
float d_a = sqrt(dx_a*dx_a+dy_a*dy_a+dz_a*dz_a);

glPushMatrix();
 glTranslatef(Srcex,Srcey,Srcez);
 glBegin(GL_LINES);
  glVertex3f( 0.0f, 0.0f, 0.0f);
  if( Flags_i & KB_FixedLength)
	{
	dx_a/= d_a; 
	dy_a/= d_a; 
	dz_a/= d_a;
	glVertex3f( dx_a* Length, dy_a* Length, dz_a* Length);
	d_a= Length;
	}
  else
	{
	glVertex3f( dx_a, dy_a, dz_a);
	dx_a/= d_a; 
	dy_a/= d_a; 
	dz_a/= d_a;
	}
 glEnd();

 glPushMatrix();
  if ( isEqual( dz_a, -1.0f) )
    glRotatef( 180.0f, 1.0f, 0.0f, 0.0f);
  else if ( !isEqual(dz_a, 1.0f) ) 
	{
   float ang= acos( dz_a)* 180/ M_PI;
   glRotatef( ang, -dy_a, dx_a, 0); 
	}
  glTranslatef( 0.0f, 0.0f, (float)( d_a- ConeLength)* 0.5);
  glPushMatrix();
   glRotatef( 90.0f, 1.0f, 0.0f, 0.0f);
   CylinderModel. h= d_a- ConeLength;
	CylinderModel. drawSolid();
  glPopMatrix();
  
 glTranslatef(0.0f, 0.0f,(float) d_a* 0.5); 
  glPushMatrix();
   glRotatef( 90.0f, 1.0f, 0.0f, 0.0f);
	ConeModel. h= ConeLength;
   ConeModel. draw();
  glPopMatrix();
 glPopMatrix();
glPopMatrix();
}
//------------------------------------------------------
void ArrowModel_ct:: drawWF( float Srcex, float Srcey, float Srcez,
	float Destx, float Desty, float Destz, unsigned Flags_i) 
{
float dx_a= Destx- Srcex;
float dy_a= Desty- Srcey;
float dz_a= Destz- Srcez;
float d_a = sqrt(dx_a*dx_a+dy_a*dy_a+dz_a*dz_a);
if( Flags & KB_FixedLength)
	{
	dx_a/= d_a; 
	dy_a/= d_a; 
	dz_a/= d_a;
	Destx= dx_a* Length;
	Desty= dy_a* Length;
	Destz= dz_a* Length;	
	d_a= Length;
	}
else
	{
	Destx= dx_a;
	Desty= dy_a;
	Destz= dz_a;	
	dx_a/= d_a; 
	dy_a/= d_a; 
	dz_a/= d_a;
	}
glPushMatrix();
 glTranslatef(Srcex,Srcey,Srcez);
 glBegin(GL_LINES);
  glVertex3f( 0.0f, 0.0f, 0.0f);
  glVertex3f( Destx, Desty, Destz);
 glEnd();

 glPushMatrix();
  float ang = acos(dz_a)* 180 / M_PI;
  glRotatef( ang, -dy_a, dx_a, 0);
  glTranslatef( 0.0f, 0.0f, d_a- ConeLength);
  glutSolidCone( ConeRadius, ConeLength, 10, 10);
 glPopMatrix();
glPopMatrix();
}
/*
//------------------------------------------------
void ArrowModel_ct:: drawWF() 
{
glPushMatrix();
 glBegin(GL_LINES);
 glVertex3f(0.0f,0.0f,0.0f);
 glVertex3f(dx,dy,dz);
 glEnd();
 glPushMatrix();
  float d = sqrt(dx*dx+dy*dy+dz*dz);
  dx/= d; 
  dy/= d; 
  dz/= d; 
  float a = acos(dz)* 180 / M_PI;
  glRotatef( a, -dy, dx, 0);
  glTranslatef( 0.0f, 0.0f, (float) d-cl);
  glutSolidCone( cr, cl, 10, 10);
 glPopMatrix();
glPopMatrix();
}
*/
//----------------------------------------------
void ArrowModel_ct:: drawSolid2( float Srcex, float Srcey, float Srcez,
	float Destx, float Desty, float Destz, unsigned ) 
{
float dx_a= Destx- Srcex;
float dy_a= Desty- Srcey;
float dz_a= Destz- Srcez;
float d = sqrt(dx_a*dx_a+dy_a*dy_a+dz_a*dz_a);
dx_a/= d; 
dy_a/= d; 
dz_a/= d;
/*
Destx= dx_a* Length;
Desty= dy_a* Length;
Destz= dz_a* Length;
*/
glPushMatrix();
 glTranslatef( Srcex+ dx_a* .5f, Srcey+ dy_a*.5f, Srcez+ dz_a*.5f);
 ArrowModel_ct( .5f* Length, ConeRadius, ConeLength, CylRadius). drawSolid( 0, 0, 0, dx_a*.5f, dy_a*.5f, dz_a*.5f);
 ArrowModel_ct( .5f* Length, ConeRadius, ConeLength, CylRadius). drawSolid( 0, 0, 0, -dx_a*.5f, -dy_a*.5f, -dz_a*.5f);
glPopMatrix();
}
//-------------------------------------------------
//-------------------------------------------------
AxesModel_ct:: AxesModel_ct(): bPrintAxesNames(0)
	, Arrowx(1.0f, 0.1f, 0.3f, 0.02f)
	, Arrowy(1.0f, 0.1f, 0.3f, 0.02f)
	, Arrowz(1.0f, 0.1f, 0.3f, 0.02f)
{
}
//----------------------------------------------------------
void AxesModel_ct:: draw( float x, float y, float z, unsigned Flags_i)
{
glColor4f(1.0f, 0.0f, 0.0f, 1.0f);
Arrowx. draw( x, y, z, x+ 1.0f, y, z, Flags_i);
glColor4f(0.0f, 1.0f, 0.0f, 1.0f);
Arrowy. draw( x, y, z, x, y+ 1.0f, z, Flags_i);
glColor4f(0.0f, 0.0f, 1.0f, 1.0f);
Arrowz. draw( x, y, z, x, y, z+ 1.0f, Flags_i);
//if( bPrintAxesNames)
//	drawAxesNames( x,y,z);
}
/*
//----------------------------------------------------------
void AxesModel_ct:: drawAxesNames( float x, float y, float z)
{
setFont(GLUT_BITMAP_8_BY_13,CENTER);
glPushAttrib(GL_DEPTH_TEST);
glDisable(GL_DEPTH_TEST);
glColor4f(0.5f, 0.0f, 0.0f, 1.0f);
drawText( x+ 1.3f, y, z,"x");
glColor4f(0.0f, 0.5f, 0.0f, 1.0f);
drawText( x, y+ 1.3f, z, "y");
glColor4f(0.0f, 0.0f, 0.5f, 1.0f);
drawText( x, y, z+ 1.3f, "z");
glPopAttrib();
}
*/
//----------------------------------------------------------
void AxesModel_ct:: draw(unsigned Flags_i)
{
draw( .0f, 0.0f, 0.0f, Flags_i);
}
//
static float AABoxTexCoord[8] = 
{
	0.0, 0.0,
	1.0, 0.0,
	1.0, 1.0,
	0.0, 1.0,
};
// Face Info
static float AABoxVtxSign[8][3] = 
	{
	{-1,  1,  1},
	{ 1,  1,  1},
	{ 1, -1,  1},
	{-1, -1,  1},
	{-1,  1, -1},
	{ 1,  1, -1},
	{ 1, -1, -1},
	{-1, -1, -1},
};
// Face Info
static int AABoxFace[6][4] = {
	// Front
	{0, 1, 2, 3},
	// Right
	{1, 5, 6, 2},
	// Back
	{5, 4, 7, 6},
	// Left
	{4, 0, 3, 7},
	// Top
	{4, 5, 1, 0},
	// Bottom
	{3, 2, 6, 7},
};
/*
// Face Normals
static float AABoxFaceNrm[6][3] = {
	// Front
	{0.0, 0.0, 1.0},
	// Right
	{1.0, 0.0, 0.0},
	// Back
	{0.0, 0.0, -1.0},
	// Left
	{-1.0, 0.0, 0.0},
	// Top
	{0.0, 1.0, 0.0},
	// Bottom
	{0.0, -1.0, 0.0},
};
*/
// Initial Face Colors
static float AABoxFaceClr[24] = 
{
	// Front
1.0, 0.0, 0.0, 1.0,
	// Right
0.0, 1.0, 0.0, 1.0,
	// Back
1.0, 0.0, 0.0, 1.0,
	// Left
0.0, 1.0, 0.0, 1.0,
	// Top
0.0, 0.0, 1.0, 1.0,
	// Bottom
0.0, 0.0, 1.0, 1.0,
};
//---------------------------------------------------------------------------
void AABoxModel_ct::draw() 
{
int i, j;

	// Draw a AABox
for(i = 0; i < 6; i++) 
	{
	glBegin(GL_QUADS);
	glColor4f( AABoxFaceClr[i * 4 + 0], AABoxFaceClr[i * 4 + 1],	AABoxFaceClr[i * 4 + 2],	AABoxFaceClr[i * 4 + 3]);
	for (j = 0; j < 4; j++) 
		{
		glTexCoord2f(AABoxTexCoord[2 * j + 0], AABoxTexCoord[2 * j + 1]);
		glVertex3f(
				w * (float)AABoxVtxSign[ AABoxFace[ i][ j]][ 0],
				h * (float)AABoxVtxSign[ AABoxFace[ i][ j]][ 1],
				l * (float)AABoxVtxSign[ AABoxFace[ i][ j]][ 2]
				);
		}
	glEnd();
	}
}
