#ifdef _WIN32
#pragma once
#endif

#ifndef UTILMODELS_H_
#define UTILMODELS_H_

enum { KB_Solid= 0, KB_WireFrame= 1, KB_FixedLength= 2,};
//+++++++++++++++++++++++++++++++++++++++++++
class AABoxModel_ct 
{
public:
	AABoxModel_ct(float W_i, float H_i, float L_i)
		: w(0.5f* W_i), h(0.5f* H_i), l(0.5f* L_i) { }

	void draw();
float w;
float h;
float l;
};
//+++++++++++++++++++++++++++++++++++++++++++
class ConeModel_ct
{
public:
int      n;
float   r;
float   h;

float * cs;
float * sn;
float * ncs;
float * nsn;

	ConeModel_ct( int n= 6, float r_i=1, float h_i=1);
	~ConeModel_ct();
	void draw(); 
	void draw( float Srcex, float Srcey, float Srcez,
		float Destx, float Desty, float Destz, int bUseModelLength_i= 0);
	void setRadiusMax( float r_i);
};
//+++++++++++++++++++++++++++++++++++++++++++
class CylinderModel_ct
{
public:
int     n;
float   r;
float   h;

float * cs;
float * sn;
float * ncs;
float * nsn;
int bDrawBases;

	CylinderModel_ct( int n_i= 6, float r_i=1, float h_i=1, int bDrawBases_i=1)
		{  set( n_i, r_i, h_i, bDrawBases_i);
		}
	~CylinderModel_ct() { clear(); }
	void setNumOfSectors( int n);
	void clear();

	void draw( float Radius_i, float Srcex, float Srcey, float Srcez,
		float Destx, float Desty, float Destz, unsigned DrawFlags, int bUseModelLength_i= 0);
	void drawWF( float Radius_i, float Srcex, float Srcey, float Srcez,
		float Destx, float Desty, float Destz, int bUseModelLength_i= 0)
		{
		draw( Radius_i, Srcex, Srcey, Srcez, Destx, Desty, Destz, KB_WireFrame, bUseModelLength_i);
		}
	void drawSolid( float Radius_i, float Srcex, float Srcey, float Srcez,
		float Destx, float Desty, float Destz, int bUseModelLength_i= 0)
		{
		draw( Radius_i, Srcex, Srcey, Srcez, Destx, Desty, Destz, KB_Solid, bUseModelLength_i);
		}
	void setRadiusMax( float r_i);
	void set( int n_i, float r_i, float h_i, int bDrawBases_i);

	void drawSolid();
	void drawWF();
};
//+++++++++++++++++++++++++++++++++++++++++++
class ArrowModel_ct
{
public:

float        Length;
float        ConeRadius;
float        ConeLength;
float        CylRadius;
ConeModel_ct      ConeModel;
CylinderModel_ct  CylinderModel;
unsigned Flags;

	ArrowModel_ct (float Length_i= 1,float ConeRadius_i= 0.1f, float ConeLength_i=0.3f, float CylRadius_i= .03f, unsigned Flags= KB_FixedLength);
	void draw( float Srcex, float Srcey, float Srcez,	float Destx, float Desty, float Destz, unsigned Flags_i);
protected:
	void drawWF( float Srcex, float Srcey, float Srcez,	float Destx, float Desty, float Destz, unsigned Flags_i= KB_FixedLength);
	void drawSolid( float Srcex, float Srcey, float Srcez,	float Destx, float Desty, float Destz, unsigned Flags_i= KB_FixedLength); 
	void drawSolid2( float Srcex, float Srcey, float Srcez,	float Destx, float Desty, float Destz, unsigned Flags_i= KB_FixedLength);
};
//+++++++++++++++++++++++++++++++++++++++++++
class AxesModel_ct
{
int bPrintAxesNames;

ArrowModel_ct  Arrowx;
ArrowModel_ct  Arrowy;
ArrowModel_ct  Arrowz;
public:
	AxesModel_ct();
	void draw(float x_i, float y_i, float z_i, unsigned Flags_i= KB_Solid| KB_FixedLength);
	void draw(unsigned Flags_i= KB_Solid| KB_FixedLength);
protected:
//	void drawAxesNames( float x_i, float y_i, float z_i);
};
//+++++++++++++++++++++++++++++++++++++++++++
class GridModel_ct
{
public:
//int   bIsToBeDrawn;

int   Side;
int   Sidex;
int   Sidey;
int   Nx;
int   Ny;
float r;
float g;
float b;
float a;

float Offsetx;
float Offsety;

	GridModel_ct(int Sidex_i=4000, int Sidey_i=4000, int Side_i=100);
	virtual ~GridModel_ct(){}
	virtual void draw();
	virtual void draw( float x, float y, float z);
	void setColor4f(float  r_i, float  g_i,float   b_i, float a_i) 
		{r=r_i; g=g_i; b=b_i; a=a_i; }
};
#endif //EOF