//"Portions Copyright (C) Dante Treglia II, 2000"
#ifdef _WIN32
#pragma once
#endif
#ifndef _GL_TEXT_H_
#define _GL_TEXT_H_

	//TODO solve Pb when undef'ed!!
#define MD_MEMPB 

#include <cstdio>
#include <cstdarg>

struct RGBAcolor_st
{
unsigned char r, g, b, a;
};

#define MF_SetRGBAcolor(c, rIn, gIn, bIn, aIn) \
	c.r = rIn; \
	c.g = gIn; \
	c.b = bIn; \
	c.a = aIn

//+++++++++++++++++++++++++++++++++++++++++++++++
class TextBox_ct 
{
public:

enum
	{ 
	MAX_STR= 4096,
	};
enum{ 
	TEXT_NONE= 0x00,
	TEXT_DRAW_BOX= 0x04,
	TEXT_DRAW_SPACES= 0x02,
	TEXT_WRAP_SPACES= 0x08,
	TEXT_DRAW_BACKGROUND= 0x01,
	};
enum{ 
	TEXT_PRINTD_UP,
	TEXT_PRINTD_DOWN,
	};
enum{ 
	FONT_W= 8,
	FONT_H= 8,
	FONT_DRAW_W= 8,
	FONT_DRAW_H= 9,
	FONT_TEX_W= 64,
	FONT_TEX_H= 128,
	};
	TextBox_ct(int boxL, int boxR, int boxT, int boxB
		, int r= 255, int g= 255, int b= 255, int a= 255
		, int Size_i= MAX_STR);
	virtual ~TextBox_ct() 
		{	delete []Buffer;
		}

int bIsToBeDrawn;

protected:
unsigned Size;
int bPrintDownwards;

	// Bounding Box
int boxL;
int boxR;
int boxT;
int boxB;

	// Text Buffers
char * Buffer;
char * pDrawBuffer;

	// Info
int pageLineCnt;
int scrollCnt;
int currX;
int currY;
RGBAcolor_st RGBAcolor;

public:
	unsigned int mode;

public:
	void Begin();
	void End();
	void DrawStr(int x, int y, char* string);
	int  draw();
	void copyadd(char* fmt, ...);
	void addLineFeed() { copyadd("\n");} // TODO SIMPLER
	void clear();
	void setPrintVertDir( int _i)
		{	bPrintDownwards= (_i== TEXT_PRINTD_DOWN);
		}
	void SetColor(RGBAcolor_st colorIn) { RGBAcolor = colorIn;}
	void SetColor4i(unsigned char r, unsigned char g,unsigned char  b, unsigned char a) 
		{RGBAcolor.r=r; RGBAcolor.g=g; RGBAcolor.b=b; RGBAcolor.a=a; };
	void setMode(unsigned int modeIn) {  mode = modeIn; }
	void PageUp() {scrollCnt += pageLineCnt;};
	void PageDown() {scrollCnt -= pageLineCnt; if (scrollCnt < 0) scrollCnt = 0;};
	void PageReset() {scrollCnt = 0;};
	virtual void update() {  }
#ifdef MD_MEMPB
	void setMem( int Size_i= MAX_STR);
#endif
private:
	void Paginate();	
	int  drawStr(int x, int y, int maxFlag, int maxY, char* string);
	void DrawBoundingBox();
	void FormatStrCat(char * str);
};
//++++++++++++++++++++++++++
class Hud_ct
{
public:
int bIsInit;
int bIsToBeDrawn;
TextBox_ct * * TxtBoxes;
int TabSize;
	Hud_ct(TextBox_ct * TextBoxes_i[]= NULL, int Size_i= 0)
		: TxtBoxes(TextBoxes_i), TabSize( Size_i){}
	void init();
	virtual void initSpec(){}
	void draw();	
	void update();
};
//++++++++++++++++++++++++++
class HudMngr_ct
{
public:
static int SelectedHudIz_s;
//static int bOrthoIsSet_s;
static Hud_ct * Huds_s[];
static Hud_ct * pCurrHud_s_(){  return Huds_s[SelectedHudIz_s];}	
static void begin_s();
static void end_s();
static void draw_s( int bOrthoIsSet_i);
/*
static void init( int bOrthoIsSet_i=0)
	{
	bOrthoIsSet_s= bOrthoIsSet_i;
	}
*/
	HudMngr_ct() {}
};
#endif 
