#include <GL/glut.h>

#include "gr_util3DObjects_ct.h"

#include <cmath>
#include <memory>

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
GridModel_ct Grid_ct::GridModel_s;
ConeModel_ct Cone2_ct:: ConeModel_s;
CylinderModel_ct Cylinder2_ct:: CylinderModel_s;
AxesModel_ct Axes_ct:: AxesModel_s;
ArrowModel_ct Arrow2_ct:: ArrowModel_s;

//-------------------------------------------------
Axes_ct::	Axes_ct( AxesModel_ct * pModel_i, float x_i, float y_i, float z_i)
	: pModel( pModel_i), x( x_i), y(y_i), z( z_i), bIsToBeDrawn(1) 
{ 
if(!pModel)
	pModel= & AxesModel_s;
}
//-------------------------------------------------
Arrow2_ct	::Arrow2_ct( unsigned int Flags_i, ArrowModel_ct * pModel_i, float Srcex_i, float Srcey_i, float Srcez_i,
	float Destx_i, float Desty_i, float Destz_i)
	: 
	Flags( Flags_i)
	, pModel(pModel_i)
	, Srcex(Srcex_i), Srcey(Srcey_i), Srcez(Srcez_i)
	, Destx(Destx_i), Desty(Desty_i), Destz(Destz_i)
{
if( !pModel)
	pModel= & ArrowModel_s;
}
//-------------------------------------------------
Cylinder2_ct::	Cylinder2_ct( CylinderModel_ct * pModel_i, float Srcex_i, float Srcey_i, float Srcez_i,
	float Destx_i, float Desty_i, float Destz_i)
	: pModel(pModel_i)
	, Srcex(Srcex_i), Srcey(Srcey_i), Srcez(Srcez_i)
	, Destx(Destx_i), Desty(Desty_i), Destz(Destz_i)
{
if( !pModel)
	pModel= & CylinderModel_s;
}
//-------------------------------------------------
Cone2_ct::	Cone2_ct( ConeModel_ct * pModel_i, float Srcex_i, float Srcey_i, float Srcez_i,
	float Destx_i, float Desty_i, float Destz_i)
	: pModel(pModel_i)
	, Srcex(Srcex_i), Srcey(Srcey_i), Srcez(Srcez_i)
	, Destx(Destx_i), Desty(Desty_i), Destz(Destz_i)
{
if( !pModel)
	pModel= & ConeModel_s;
}
//-------------------------------------------------
Grid_ct:: Grid_ct( GridModel_ct * pModel_i, float x_i, float y_i, float z_i)
	: pModel( pModel_i), x( x_i), y(y_i), z(z_i), bIsToBeDrawn(1) 
{ 
if(!pModel)
	pModel= & GridModel_s;
}
//-------------------------------------------------
LeveledGrid_ct:: LeveledGrid_ct(int Sidex_i, int Sidey_i, int Size_i)
	: GridModel_ct( Sidex_i, Sidey_i, Size_i), x(0), y(0), z(0)
{
Val= new float[ Nx* Ny];
clearVal();
} 
//-------------------------------------------
void LeveledGrid_ct:: draw()
{
draw( 0.0f, 0.0f, 0.0f);
}
//-------------------------------------------
void LeveledGrid_ct:: draw( float x_i, float y_i, float z_i)
{
glPushMatrix();

glTranslatef( x_i-Offsetx, y_i-Offsety, z_i);

glLineWidth( 1);
glColor4f(r,g,b,a);
glEnable(GL_LINE_STIPPLE);
glLineStipple(1,0x5555);

for( int i=0; i< Nx; i++)
	{
	glBegin(GL_LINE_STRIP);
	for( int j= 0; j< Ny; j++)
		{
		glVertex3f((float)i* Side, (float)j*Side, (*this)(i,j));
		}
	glEnd();
	}
for( int j =0; j< Ny; j++)
	{
	glBegin( GL_LINE_STRIP );
	for( int i= 0; i< Nx; i++)
		{
		glVertex3f(i* Side, j*Side, (*this)(i,j));
		}
	glEnd();
	}
glDisable(GL_LINE_STIPPLE);

glPopMatrix();
}
//-----------------------------------------------
inline void LeveledGrid_ct:: clearVal()
{
memset( Val, 0x00, Nx* Ny* sizeof(float));
}
//-----------------------------------------------
int LeveledGrid_ct:: recalc( void) 
{ 
if( !eval)
	{
	clearVal();
	return 1;
	}
for( int i =0; i< Nx; i++)
	for( int j= 0; j< Ny; j++)
		(*this)(i,j)= eval(i*Nx, j*Ny);
return 0;
}
//-------------------------------------------------
