/* 
 * HL rendering engine
 * Copyright (c) 2000,2001 Bart Sekura
 *
 * Permission to use, copy, modify and distribute this software
 * is hereby granted, provided that both the copyright notice and 
 * this permission notice appear in all copies of the software, 
 * derivative works or modified versions.
 *
 * THE AUTHOR ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS"
 * CONDITION AND DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES 
 * WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * core render class
 */

//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
//
// See the GNU General Public License for more details at:
// http://www.gnu.org/copyleft/gpl.html
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#ifndef __render_h__
#define __render_h__

#ifndef __linux__
#include "glwin.h"
#else
#include <GL/glut.h>
#endif

#include "bspfile2.h"
//#include "mathlib.h"
#include "mathlib_tpl.h"

#include "vis.h"

//#include "plane.h"
//#include "RenderFace_ct.h"
#include "matrix.h"

class DispList {
public:
    DispList() { m_id = glGenLists(1); }
    ~DispList() { glDeleteLists(m_id,1); }

    void begin() const { glNewList(m_id, GL_COMPILE); }
    void end() const { glEndList(); }
    void render() const { glCallList(m_id); }
    GLuint id() const { return m_id; }

private:
    GLuint    m_id;
};

///////////////////////////////////////////////////

//////////////////////////////////////////////////////
//
#ifdef WIN32
class Render : public GLWindow 
{
#else
class Render 
{
#endif

public:
    Render();
    ~Render();

    void InitRender();
    void frame();

    virtual void resize();
    virtual void init();
    virtual void shutdown();

    void display_screen();
};
#endif // __render_h__
