#ifdef WIN32
#pragma once
#endif
#ifndef RESIZABLEVECTOR_TPL_H_
#define RESIZABLEVECTOR_TPL_H_
//#include <vector>
	//resizable vector of T 
#include <cassert>
//+++++++++++++++++++++++++++++++++++++++++++++++++++
template<typename T, const int KT_SizeIncrem>
class RszVector_cT 
{
public:
    RszVector_cT( int Size_i= 0): SizeMax(Size_i), Size(Size_i), Data(0)
		{	Data= (Size_i? new T[ Size_i]: 0);
		}
    ~RszVector_cT() 
		{   delete []Data;
		}
	RszVector_cT( const RszVector_cT & A_i)
		{
		SizeMax= A_i. Size;//SizeMax;
		Size= A_i. Size;
		Data= new T[ SizeMax];
		memcpy( Data, A.Data, Size* sizeof(T));
		}
	RszVector_cT & operator=( const RszVector_cT & A_i)
		{
		if( this!= & A_i)
			{
			SizeMax= A_i. Size;//SizeMax;
			Size= A_i. Size;
			if( Data)
				delete[] Data;
			Data= new T[ SizeMax];
			memcpy( Data, A.Data, Size* sizeof(T));
			}
		return *this;
		}

	void clear()
		{	
		delete []Data;
		init0();
		}
/*
	void reset()
		{
		delete Data[];//clear();
		init();
		}
*/
	void reserve( int SizeMax_i)
		{
		delete []Data;
		Data= new T[ SizeMax_i];
		SizeMax= SizeMax_i;
		Size=0;
		}
	void resize( int Size_i)
		{
	   if( SizeMax<= Size_i) 
			resize0( Size_i);
		if( Size> Size_i) 
			Size= Size_i;
		}

	void push_back( const T & ToAdd_i)
		 {
		 if( SizeMax== Size) 
         resize0( SizeMax+ KT_SizeIncrem);
      memcpy( Data+ Size, & ToAdd_i, sizeof(T));
		++Size;
		}
	void pop_back()
		{	--Size;
		}

   void adjustsize()
		{
		if( Size== SizeMax)
			return;
		T * Adj_n=0;
		if( Size!=0)
			{
			Adj_n= new T[Size];
			memcpy( Adj_n, Data, Size* sizeof(T));
			}
		delete[]Data;
		Data= Adj_n;
		SizeMax= Size;
		}
	int transfer(T * * Dest_a, int bAdjustSize_i=1)
		{
		if(bAdjustSize_i)
			adjustsize();
		*Dest_a= 0;
		if(!Data)	
			return 0;
		int Size_a= Size;
		*Dest_a= Data;
		Data=0;
		Size=	SizeMax=0;
		return Size_a;
		}
	 operator T *() {  return Data; }
	 const T & operator[](int i) const 
		{ 
		assert(i< Size && "RszVector_cT: index outside range");
		return *(Data+i); 
		}
    T & operator[](int i) 
		{ 
		assert(i< Size && "RszVector_cT: index outside range");
		return *(Data+ i); 
		}
/*
	 T & front() {  return *Data;}	
	 const T & front() const{  return *Data;}	

	 T & back() {  return *(Data+ Size-1);}	
	 const T & back() const{  return *(Data+ Size-1);}	
*/
	 int size()  const { return Size;}
	 bool empty() const { return Size==0; }

//private:
int SizeMax;
int Size;
T * Data;

	void init0()
		{
		Data= 0;
		SizeMax= 0;
		Size= 0;
		}
	void resize0( int Size_i)
		{
		T* NewData_n= new T[Size_i];
      memcpy( NewData_n, Data, Size*sizeof(T));
		delete[] Data;
      Data= NewData_n;
		SizeMax= Size_i;
		}
};
/*
//implementation based on owned pointers
//+++++++++++++++++++++++++++++++++++++++++++++++++++
template<typename T, const int KT_SizeIncrem>
class RszPVector_cT 
{
public:
static enum { K_PointerCopy, K_Clone, K_TransferOwner};
typedef T * PtrOnData_t;
PtrOnData_t * DataPtrs;
int SizeMax;
int Size;

   RszPVector_cT( int NumElm_i= 0): PtrOnData(0)
		{	reset( (NumElm_i? NumElm_i: KT_SizeIncrem));
		}
	RszPVector_cT( const RszPVector_cT & A_i)
		{	clone(A_i);
		}
	
	RszPVector_cT & operator=( const RszPVector_cT & A_i)
		{
		if( this!=& A_i)
			clone(A_i);
		return *this;
		}

    ~RszPVector_cT() 
		{   clear();
		}

	void reset( int NumElm_i= 0)
		{
      clear();
		if( NumElm_i)
			{
			SizeMax= NumElm_i;
			DataPtrs= new PtrOnData_t[SizeMax];
			}
		}
	void resetFill( int NumElm_i= 0)
		{
      reset(NumElm_i);
		Size= SizeMax;
		}

	int destroyData( int Index_i)
		{
		delete DataPtrs+ Index_i;
		DataPtrs+ Index_i= 0;
		}
	void clear()
		{
		if( DataPtrs)
			{
			int i= 0;
			while(i< Size) delete DataPtrs[i++];
         delete[] DataPtrs;
			DataPtrs= 0;
			}
		SizeMax= 0;
		Size= 0;
		}
private:
	void copyFull( const RszPVector_cT & A_i)
		{
		if( DataPtrs && SizeMax< A_i. Size)
			{
			clear();
			SizeMax= A_i. Size;
			Size= A_i. Size;
			DataPtrs= new PtrOnData_t[ Size];
			}
		else
			{
			Size= A_i. Size;
			}
		for(int i= 0; i< Size; i++)  *(DataPtrs+i)= *(A_i. DataPtrs+i);
		}
public:
     void resize( int NewSize_i= SizeMax+ KT_InitElmSize)
		{
      if( NewSize_i> SizeMax)
			{
			PtrOnData_t NewData_n= new PtrOnData_t[NewSize_i];
			if( DataPtrs)
				{
				if( Size)
					memcpy( NewData_n, DataPtrs, Size);
				delete[] DataPtrs;
				}
			DataPtrs= NewData_n;
			SizeMax= NewSize_i;
			}
		}
	  
	  void push_back( const T & Source_i) 
		 {
		 if( Size== SizeMax) 
			resize( SizeMax+ KT_InitElmSize);
		*(DataPtrs+ Size)= Source_i;
      ++Size;
		}


    T * first() 	{ return (Size? DataPtrs: 0); 	}
    const T * first() const 	{ return (Size? DataPtrs: 0); 	}
    T * last() 	{ return ((DataPtrs && Size)? DataPtrs+ Size- 1: 0); }
    const T * last() const 	{ ((DataPtrs && Size)? DataPtrs+ Size- 1: 0); 	}

    const T * operator[](int i) const 	{ return DataPtrs+ i; 	}
    T * operator[](int i) 	{ return DataPtrs+ i; 	}

    const T & operator[](int i) const 	{ return *(DataPtrs+ i); 	}
    T & operator[](int i) 	{ return *(DataPtrs+ i); 	}

    T & front() 	{ return *(DataPtrs+ i); 	}
    const T & front() const 	{ return *(DataPtrs); 	}
    T & back() 	{ return Size? *(DataPtrs+ Size- 1): *(DataPtrs); 	}
    const T & back() const 	{ return *(DataPtrs+ Size- 1); 	}
	 int size() const{ return Size;	}
	 bool empty() const { return Size== 0; }
};
*/

#if 0
//+++++++++++++++++++++++++++++++++++++++++++++++++++
template<typename T, const int KT_SizeIncrem>
class RszPVector_cT 
{
public:
static enum { K_PointerCopy, K_Clone, K_TransferOwner};
typedef T * PtrOnData_t;
PtrOnData_t * DataPtrs;
int bIsOwner;
int SizeMax;
int Size;

   RszPVector_cT( int bIsOwner_i, int NumElm_i= 0): bIsOwner(bIsOwner_i), PtrOnData(0)
		{	reset( (NumElm_i? NumElm_i: KT_SizeIncrem));
		}
	RszPVector_cT( const RszPVector_cT & A_i, int CopyMode_i= K_PointerCopy)
		{
		if( CopyMode_i== K_Clone)
			clone(A_i);
		else			
			copyPointers(A_i, CopyMode_i);
		}
private:	
	RszPVector_cT & operator=( const RszPVector_cT & A_i);
public:
    ~RszPVector_cT() 
		{   clear();
		}

	void reset( int NumElm_i= 0)
		{
      clear();
		if( NumElm_i)
			{
			SizeMax= NumElm_i;
			DataPtrs= new PtrOnData_t[SizeMax];
			}
		}
	void resetFill( int NumElm_i= 0)
		{
      reset(NumElm_i);
		Size= SizeMax;
		}

	void destroyData( int Index_i)
		{
		if( bIsOwner)
			delete DataPtrs+ Index_i;
		DataPtrs+ Index_i= 0;
		}
/*
	void removePointer( int Index_i)
		{	DataPtrs+ Index_i= 0;		
		}
*/
private:
	void destroyData()
		{
		if( DataPtrs)
			{
			int i= 0;
			while(i< Size)	delete DataPtrs[i++];
			}
		}
public:
	void clear()
		{
		if( bIsOwner)
			destroyData();
      if( DataPtrs) 
        delete[] DataPtrs;
		DataPtrs= 0;
		SizeMax= 0;
		Size= 0;
		}
	void clone( const RszPVector_cT & A_i)
		{
		SizeMax= A_i. Size;
		Size= A_i. Size;
		if( DataPtrs)
			clear();
		DataPtrs= new PtrOnData_t[ Size];
		for(int i= 0; i< Size; i++)	*(DataPtrs+i)= *(A_i. DataPtrs+i);
		}
	int copyPointers( const RszPVector_cT & A_i, int CopyMode_i= K_PointerCopy)
		{
		//copy pointers, not pointed T Data
		SizeMax= A_i. Size;
		Size= A_i. Size;
		if( DataPtrs)
			clear();
		DataPtrs= new PtrOnData_t[ Size];
		memcpy( DataPtrs, A_i. DataPtrs, Size);
		bIsOwner= 0;
		if( CopyMode_i== K_TransferOwner)
			{
			if( A_i. bIsOwner== 0)
				return 1;//pb		
			bIsOwner= 1;
			return 0;
			}
		else
			return 0;
		}
public:
     void resize( int NewSize_i= SizeMax+ KT_InitElmSize)
		{
      if( NewSize_i> SizeMax)
			{
			PtrOnData_t NewData_n= new PtrOnData_t[NewSize_i];
			if( DataPtrs)
				{
				if( Size)
					{
					memcpy( NewData_n, DataPtrs, Size);
					//for( int i= 0; i< OldSize_a; i++) 
						// NewData_n[i]= PtrOnData[i];
					}
				delete[] DataPtrs;
				}
			DataPtrs= NewData_n;
			SizeMax= NewSize_i;
			}
		}
	  
	  void push_back( const T & Source_i) 
		 {
		 if( Size== SizeMax) 
			resize( SizeMax+ KT_InitElmSize);
		*(DataPtrs+ Size)= Source_i;
      ++Size;
		}

    T * first() 	{ return Size? DataPtrs: 0; 	}
    const T * first() const 	{ return DataPtrs; 	}
    T * last() 	{ return (DataPtrs && Size)? DataPtrs+ Size- 1: 0}
    const T * last() const 	{ return DataPtrs; 	}

    const T * operator[](int i) const 	{ return DataPtrs+ i; 	}
    T * operator[](int i) 	{ return DataPtrs+ i; 	}

    const T & operator[](int i) const 	{ return *(DataPtrs+ i); 	}
    T & operator[](int i) 	{ return *(DataPtrs+ i); 	}

    T & front() 	{ return *(DataPtrs+ i); 	}
    const T & front() const 	{ return *(DataPtrs); 	}
    T & back() 	{ return Size? *(DataPtrs+ Size- 1): *(DataPtrs); 	}
    const T & back() const 	{ return *(DataPtrs+ Size- 1); 	}
	 int size() const{ return Size;	}
	 bool empty() const { return Size== 0; }
};
#endif

#endif //eof