#ifdef _WIN32

#define STRICT
//#define WIN32_LEAN_AND_MEAN  Not here!
#include <windows.h>
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
int getNewFileName( char * PFnE_o, const char * Filter_i=0, const char * InitialDir_i=0);
int getNewFileName( char * PFnE_o, HINSTANCE HInstance_i, HWND HWnd_i, const char * Filter_i=0, const char * InitialDir_i=0);
int getSaveAsFileName( char * PFnE_o, const char* InitialDir_i=0);
int getSaveAsFileName( char * PFnE_o, HINSTANCE HInstance_i, HWND HWnd_i, const char* InitialDir_i=0);
int getOpenFileName( char * PFnE_o, const char * Filter_i=0, const char * InitialDir_i=0);
int getOpenFileName( char * PFnE_o, HINSTANCE HInstance_i, HWND HWnd_i, const char * Filter_i=0, const char * InitialDir_i=0);
//================================================
//-----------------------------------------------------------
BOOL CenterWindow(HWND hWnd)
{
RECT    rRect, rParentRect;
HWND    hParentWnd;
int     wParent, hParent, xNew, yNew;
int     w, h;

GetWindowRect (hWnd, &rRect);
w= rRect.right - rRect.left;
h= rRect.bottom - rRect.top;

hParentWnd = GetDesktopWindow();
GetWindowRect( hParentWnd, &rParentRect );

wParent = rParentRect.right - rParentRect.left;
hParent = rParentRect.bottom - rParentRect.top;

xNew= wParent/ 2- w/ 2+ rParentRect.left;
yNew= hParent/ 2- h/ 2+ rParentRect.top;

return SetWindowPos (hWnd, NULL, xNew, yNew, 0, 0, SWP_NOSIZE | SWP_NOZORDER);
}
//-----------------------------------------------------------------------------
UINT CALLBACK CenterOpenDlgBox(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
LPOFNOTIFY pNotify;

switch (uMsg)
   {
   case WM_NOTIFY:
      pNotify = (LPOFNOTIFY)lParam;
      if (pNotify->hdr.code == CDN_INITDONE)
         {
         CenterWindow( GetParent(hWnd) );
         return( TRUE );
         }
	}
return( FALSE );
}
//------------------------------------------------
int getNewFileName( char * PFnE_o, const char * Filter_i, const char * InitialDir_i)
{
return getNewFileName( PFnE_o, 0, 0, Filter_i, InitialDir_i);
}
//---------------------------------------------
int getSaveAsFileName( char * PFnE_o, const char* InitialDir_i)
{
return getSaveAsFileName( PFnE_o, 0,0, InitialDir_i);
}
//---------------------------------------------
int getOpenFileName( char * PFnE_o, const char * Filter_i, const char * InitialDir_i)
{ 
return getOpenFileName( PFnE_o, 0, 0, Filter_i, InitialDir_i);
}
//---------------------------------------------
int getNewFileName( char * PFnE_o, HINSTANCE HInstance_i, HWND HWnd_i, const char * Filter_i, const char * InitialDir_i)
{
char szFile_a[256]="";
char Filters_a[ 256]="";
if( Filter_i)
	{
	strcpy( Filters_a, Filter_i);
//	if( Filters_a[0])
//		{
		for( int index_a=0; Filters_a[index_a]!='\0'; index_a++)
			if (Filters_a[index_a]== '|')
				 Filters_a[index_a]= '\0';
//		}
	}
OPENFILENAME OFN_a;
memset( &OFN_a, 0, sizeof( OPENFILENAME ) );
	 OFN_a. lStructSize        = sizeof(OPENFILENAME);
    OFN_a. hwndOwner         = HWnd_i;
    OFN_a. hInstance         = HInstance_i;
/*
    OFN_a. lpstrFilter       = NULL;
    OFN_a. lpstrCustomFilter = NULL;
    OFN_a. nMaxCustFilter    = 0;
    OFN_a. nFilterIndex      = 0;
    OFN_a. lpstrFile         = NULL;//szFile
    OFN_a. nMaxFile          = 0;//sizeof(szFile);
    OFN_a. lpstrFileTitle    = NULL;
    OFN_a. nMaxFileTitle     = 0;
    OFN_a. lpstrInitialDir   = NULL;
    OFN_a. lpstrTitle        = "";
    OFN_a. nFileOffset       = 0;
    OFN_a. nFileExtension    = 0;
    OFN_a. lpstrDefExt       = NULL;
    OFN_a. lCustData         = NULL;
	 OFN_a. lpfnHook 		   = 0;//ComDlg32DlgProc;
	 OFN_a. lpTemplateName    = 0;//MAKEINTRESOURCE(IDD_COMDLG32);
    OFN_a. Flags             = OFN_NOCHANGEDIR;//OFN_ENABLETEMPLATE| OFN_SHOWHELP | OFN_EXPLORER | OFN_ENABLEHOOK;
*/
OFN_a. lpstrFilter       = Filters_a;
OFN_a. lpstrFile         = szFile_a;
OFN_a. nMaxFile          = sizeof(szFile_a);
OFN_a. lpstrTitle        = "Open a New Session";
OFN_a. lpstrInitialDir   = InitialDir_i;

OFN_a. lpfnHook = CenterOpenDlgBox;
OFN_a. Flags|= OFN_PATHMUSTEXIST
	| OFN_FILEMUSTEXIST
	| OFN_NONETWORKBUTTON
	| OFN_HIDEREADONLY
	| OFN_CREATEPROMPT
	| OFN_EXPLORER 
	| OFN_ENABLESIZING 
	| OFN_ENABLEHOOK;

if( GetOpenFileName(&OFN_a))
   {
	strcpy( PFnE_o, OFN_a.lpstrFile);
	return 0;
	}
return 1;
}
//------------------------------------------------------
int getOpenFileName( char * PFnE_o, HINSTANCE HInstance_i, HWND HWnd_i, const char * Filter_i, const char * InitialDir_i)
{
char szFile_a[256]= "\0";
OPENFILENAME OFN_a;
memset( &OFN_a, 0, sizeof( OPENFILENAME ) );
OFN_a. lStructSize        = sizeof(OPENFILENAME);
OFN_a. hwndOwner         = HWnd_i;
OFN_a. hInstance         = HInstance_i;
OFN_a. lpstrFile         = szFile_a;
OFN_a. nMaxFile          = sizeof(szFile_a);
OFN_a. lpstrTitle        = "Open a Saved Session";
OFN_a. lpstrInitialDir   = InitialDir_i;
OFN_a. lpstrFilter       = Filter_i;
OFN_a. Flags|= OFN_PATHMUSTEXIST
	| OFN_FILEMUSTEXIST
	| OFN_NONETWORKBUTTON
	| OFN_HIDEREADONLY
	| OFN_CREATEPROMPT
	;//OFN_OVERWRITEPROMPT

if( GetOpenFileName( &OFN_a))
    {
	 strcpy( PFnE_o, szFile_a);
	 return 0;
    }
return 1;
}
//------------------------------------------------------
int getSaveAsFileName( char * PFnE_o, HINSTANCE HInstance_i, HWND HWnd_i, const char* InitialDir_i)
{
char szFile_a[256]= "";
OPENFILENAME OFN_a;
memset( &OFN_a, 0, sizeof(OPENFILENAME) );
OFN_a. lStructSize        = sizeof(OPENFILENAME);
OFN_a. hwndOwner         = HWnd_i;
OFN_a. hInstance         = HInstance_i;
OFN_a. lpstrFile         = szFile_a;
OFN_a. nMaxFile          = sizeof(szFile_a);
OFN_a. lpstrTitle        = "Save Session As";
OFN_a. lpstrInitialDir   = InitialDir_i;
OFN_a. Flags|= OFN_PATHMUSTEXIST
	| OFN_NONETWORKBUTTON
	| OFN_HIDEREADONLY
	| OFN_CREATEPROMPT
	| OFN_OVERWRITEPROMPT;

if( GetSaveFileName( &OFN_a))
    {
	 strcpy( PFnE_o, szFile_a);
    return 0;
    }
return 1;
}
/*

char* OpenNewFile( HWND hwnd, const char *wndTitle )
{
    static char file[256];
    static char fileTitle[256];
    static char filter[] = "X files (*.x)\0*.x\0"
			   "All Files (*.*)\0*.*\0";
    OPENFILENAME ofn;

    lstrcpy( file, "");
    lstrcpy( fileTitle, "");

    ofn.lStructSize       = sizeof(OPENFILENAME);
    ofn.hwndOwner         = hwnd;

    ofn.hInstance         = (HINSTANCE) GetWindowLong(hwnd, GWL_HINSTANCE);
    ofn.lpstrFilter       = filter;
    ofn.lpstrCustomFilter = (LPSTR) NULL;
    ofn.nMaxCustFilter    = 0L;
    ofn.nFilterIndex      = 1L;
    ofn.lpstrFile         = file;
    ofn.nMaxFile          = sizeof(file);
    ofn.lpstrFileTitle    = fileTitle;
    ofn.nMaxFileTitle     = sizeof(fileTitle);
    ofn.lpstrInitialDir   = NULL;
    ofn.lpstrTitle        = wndTitle;
    ofn.nFileOffset       = 0;
    ofn.nFileExtension    = 0;
    ofn.lpstrDefExt       = "*.x";
    ofn.lCustData         = 0;

    ofn.Flags = OFN_SHOWHELP | OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST;

    if (GetOpenFileName(&ofn))
        return (char*)ofn.lpstrFile;
    else
        return NULL;
}
*/
#endif