//
// BSP_tool - botman's Half-Life BSP utilities
//
// (http://planethalflife.com/botman/)
//
// vis.cpp
//
// Copyright (C) 2001 - Jeffrey "botman" Broome
//
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
//
// See the GNU General Public License for more details at:
// http://www.gnu.org/copyleft/gpl.html
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#include "appGene.h"
#include "cmdlib.h"
#include "bspfile2.h"
#include "vis.h"

//---------------------------------------------
void Visibility_ct::Decompress_VIS()
	{
    int count;
    int i, c, index;
    unsigned char bit;

    VisLeafs= new vis_leaf_t[ pHLBspFile-> numleafs];

    if (VisLeafs == NULL)
        Error("Error allocating memory for leaf visibility!\n");

    for (i = 0; i < pHLBspFile-> numleafs; i++)
		{
        int v = pHLBspFile-> dleafs[i].visofs;

        count = 0;

        // first count the number of visible leafs...
        for (c = 1; c < pHLBspFile-> dmodels[0].visleafs; v++)
			{
            if (pHLBspFile-> dvisdata[v] == 0)
            {
                v++;
                c += (pHLBspFile-> dvisdata[v]<<3);
            }
            else
            {
                for (bit = 1; bit; bit<<=1,c++)
                {
                    if (pHLBspFile-> dvisdata[v] & bit)
                       count++;
                }
            }
        }

        if (count > 0)
        {
            // allocate space to store the uncompressed VIS bit set...
            VisLeafs[i].LeafIds = new int[ count];

            if (VisLeafs[i].LeafIds == NULL)
                Error("Error allocating memory for leaf visibility!\n");
        }
        else
           VisLeafs[i].LeafIds = NULL;  // no leafs are visible

        VisLeafs[i].num_leafs = count;
    }

    // now go through the VIS bit set again and store the VIS leafs...

    for (i=0; i < pHLBspFile-> numleafs; i++)
    {
        int v = pHLBspFile-> dleafs[i].visofs;

        index = 0;

        for (c = 1; c < pHLBspFile-> dmodels[0].visleafs; v++)
        {
            if (pHLBspFile-> dvisdata[v] == 0)
            {
                v++;
                c += (pHLBspFile-> dvisdata[v]<<3);
            }
            else
            {
                for (bit = 1; bit; bit<<=1,c++)
                {
                    if (pHLBspFile-> dvisdata[v] & bit)
                    {
                        if (VisLeafs[i].LeafIds != NULL)
                            VisLeafs[i].LeafIds[index] = c;
                        index++;
                    }
                }
            }
        }
    }
}


