//
// Copyright (C) 2001 - Jeffrey "botman" Broome
//
// modified by SamPlay
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
//
// See the GNU General Public License for more details at:
// http://www.gnu.org/copyleft/gpl.html
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#include "appgene.h"
#ifdef WIN32
int getNewFileName( char * PFnE_o, const char * Filter_i=0, const char * InitialDir_i=0);
#endif

#include "bspfile2.h"
#include "world_ct.h"
#include "HalfLifeMods_ct.h"

extern char MapName[];
extern char HalfLifeDir[];
extern HalfLifeMods_ct HalfLifeMods;

int     FileTime (char *path);//"cmdlib.h"
void    StripExtension (char *path);//"cmdlib.h"
void    Error( char *,...);//"cmdlib.h" or 
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
#ifndef M_PATHSEP
#ifndef __linux__
 #define M_PATHSEP "\\"
#else
 #define M_PATHSEP "/"
#endif
#endif

HLBspFile_ct HLBspFile;
float WorldSizeMax;
float WorldHalfSizeMax;
//=============================================
inline unsigned getBspLoadFlags( int WorldLoad_i)
{
if( WorldLoad_i== World_ct:: K_LW_ForBot)
	return HLBspFile_ct::KB_LD_BspCore;
else
	return ~0;//all
}
//--------------------------------------------
World_ct::World_ct(): pHLBspFile( NULL)
{
for(int i=0; i<3; i++)
	Mins[i]= Maxs[i]=0;

}
//---------------------------------------------------------------
#ifdef _WIN32
int win_getMapName ()
	{
   int Fail_a;
   char Buf_a[ 512];
	sprintf( Buf_a, "BSP Files (*%s)|*%s|", ".bsp", ".bsp");
	if (HalfLifeMods. mods[0].dir[0])
      Fail_a= ::getNewFileName( MapName, Buf_a, HalfLifeDir);
   else
      Fail_a= ::getNewFileName( MapName, Buf_a, 0);
	if( Fail_a)
      {
		Error("You must specify a BSP file!\n");
		return 1;
		}
	else
		StripExtension( MapName);
	return 0;
   }
#endif
//---------------------------------------------------
int World_ct:: loadBSP ( int ToLoad_i, int Input_i)
{
unsigned BspLoadFlags_a= getBspLoadFlags( ToLoad_i);

char BspFE_a[512];
strcpy( BspFE_a, MapName);
strcat( BspFE_a,".bsp");

if( Input_i && FileTime(BspFE_a)!= -1)
	{
	HLBspFile. loadFile( BspFE_a, BspLoadFlags_a);
	pHLBspFile= & HLBspFile;
	HalfLifeMods. getbsp_mod_index( BspFE_a);
	return 0;
	}

char PFE_a[ 512];
char bsp_PFnE_a[ 512];

int mod_index_a = 0;
sprintf( bsp_PFnE_a, "%s%s", "maps"M_PATHSEP, BspFE_a);
while( mod_index_a <HalfLifeMods. num_mods)
   {
   strcpy( PFE_a, HalfLifeMods. mods[ mod_index_a].dir);
	strcat( PFE_a, bsp_PFnE_a);
      // check if the .bsp file exists...
   if(FileTime(PFE_a)!= -1)
      {
      HLBspFile. loadFile( PFE_a, BspLoadFlags_a);
     	pHLBspFile= & HLBspFile;
		HalfLifeMods. pModDir= HalfLifeMods. mods[ mod_index_a].dir;
		HalfLifeMods. bsp_mod_index = mod_index_a;
      return 0;
      }
   mod_index_a++;
   }
if( !HLBspFile.loadPakBSPFile( bsp_PFnE_a, BspLoadFlags_a))
	return 1;//pb
pHLBspFile= & HLBspFile;
return 0;
}
//---------------------------------------------------------------
int World_ct:: loadBSPPlus ( int ToLoad_i)
{
int Input_a= -1;//assumes MapName is relevant

if( MapName[0]=='\0')
	{
	Input_a= 1;//problem
	#ifdef WIN32
	Input_a= ::win_getMapName();// return 0 if ok; this also means that we are sure that the file exists
	#endif
	if( Input_a> 0)
		{   
		Error("You must specify a BSP filename to load!\n");
		return Input_a;
		}
	}

if( loadBSP ( ToLoad_i, Input_a))
	{
	Error("Cannot load map: %s\n", MapName);
	return 1;
	}

	//pModel_s = &dmodels[0];  // model 0 is the BSP world
VectorCopy(pHLBspFile-> dmodels[0]. mins, Mins);
VectorCopy(pHLBspFile-> dmodels[0]. maxs, Maxs);

vec3_t Delta_a;
VectorSubtract( Maxs, Mins, Delta_a);
WorldSizeMax= 1+VectorLength( Delta_a);
WorldHalfSizeMax= 0.5*WorldSizeMax;

parseEntities( pHLBspFile);
loadEntVars( pHLBspFile);

return 0;
}
